/**
 * Le schema d'architecture, sur lequel on affiche des infos
 * et des animations.
 *
 * @version 1.0 19/03/00
 * @author Paul Ladeveze
 * @author Frederik Sackx
 */
package Interface.IArchi;

import javax.swing.*;
import java.awt.*;
import java.util.Vector;

import Utilitaires.PixConstants;

public class Visual extends JPanel

{
  /** Verrou */
  private static boolean sLock=false;
  
  /** la classe parente UIArchi */
  private UIArchi mArchiInterface;
  
  /** Position du compteur suivant les diffrents modes */
  private int     mPCBoxPosX;
  private int     mPCBoxPosY;
  
  /** Position de l'opration de l'UAL suivant les diffrents modes */
  private int     mUALBoxPosX;
  private int     mUALBoxPosY;
  
  /** Position des registres suivant les diffrents modes */
  private int     mRegBoxPosX;
  private int     mRegBoxPosY;
  private int     mRegHeight;
  
  /** Les dcalages entre l'image et son panel */
  private int     mXOffset=0;
  private int     mYOffset=0;
  
  /** Les tailles des parties a redessiner pour metre a jour l'UAL, les registres et le cpt prog */
  private int     mPCBoxSize1X;
  private int     mPCBoxSize1Y;
  private int     mUALBoxSize1X;
  private int     mUALBoxSize1Y;
  private int     mRegBoxSize1X;
  private int     mRegBoxSize1Y;
  private int     mPCBoxSize2X;
  private int     mPCBoxSize2Y;
  private int     mUALBoxSize2X;
  private int     mUALBoxSize2Y;
  private int     mRegBoxSize2X;
  private int     mRegBoxSize2Y;
  
  /** La squence d'animations a effectuer */
  private Vector  mAnimStates = new Vector();
  
  /** L'animation a effectuer */
  private int     mAnimState;
  
  /** Animee ou pas */
  private boolean mIsAnimated;
  
  /** Couleur d'animation */
  private Color   mAnimColor=new Color(102,102,153 );
  
  /** le cot graphique */
  private Graphics mGraphic;
  
  /** Les positions des bus */
  private int bus1PosX1;
  private int bus1PosX2;
  private int bus1PosY1;
  private int bus1PosY2;
  private int bus2PosX1;
  private int bus2PosX2;
  private int bus2PosY1;
  private int bus2PosY2;
  private int bus3PosX1;
  private int bus3PosX2;
  private int bus3PosY1;
  private int bus3PosY2;
  private int bus3RegPosX1;
  private int bus3RegPosX2;
  private int bus3RegPosY1;
  private int bus3RegPosY2;
  private int regBus1PosX1;
  private int regBus1PosX2;
  private int regBus1PosY1;
  private int regBus1PosY2;
  private int regBus2PosX1;
  private int regBus2PosX2;
  private int regBus2PosY1;
  private int regBus2PosY2;
  private int bus1MemPosX1;
  private int bus1MemPosX2;
  private int bus1MemPosY1;
  private int bus1MemPosY2;
  private int bus2MemPosX1;
  private int bus2MemPosX2;
  private int bus2MemPosY1;
  private int bus2MemPosY2;
  private int memBus3PosX1;
  private int memBus3PosX2;
  private int memBus3PosY1;
  private int memBus3PosY2;
  private int bus1UalPosX1;
  private int bus1UalPosX2;
  private int bus1UalPosY1;
  private int bus1UalPosY2;
  private int bus2UalPosX1;
  private int bus2UalPosX2;
  private int bus2UalPosY1;
  private int bus2UalPosY2;
  private int ualBus3PosX1;
  private int ualBus3PosX2;
  private int ualBus3PosY1;
  private int ualBus3PosY2;
  private int bus3RegIPosX1;
  private int bus3RegIPosX2;
  private int bus3RegIPosY1;
  private int bus3RegIPosY2;
  private int regIBus2PosX1;
  private int regIBus2PosX2;
  private int regIBus2PosY1;
  private int regIBus2PosY2;
  private int bus3RadmPosX1;
  private int bus3RadmPosX2;
  private int bus3RadmPosY1;
  private int bus3RadmPosY2;
  private int radmBus1PosX1;
  private int radmBus1PosX2;
  private int radmBus1PosY1;
  private int radmBus1PosY2;
  private int bus3CptPosX1;
  private int bus3CptPosX2;
  private int bus3CptPosY1;
  private int bus3CptPosY2;
  private int cptBus1PosX1;
  private int cptBus1PosX2;
  private int cptBus1PosY1;
  private int cptBus1PosY2;
  private int cptCptPlusPosX1;
  private int cptCptPlusPosX2;
  private int cptCptPlusPosY1;
  private int cptCptPlusPosY2;
  private int cptPlusCptPosX1;
  private int cptPlusCptPosX2;
  private int cptPlusCptPosY1;
  private int cptPlusCptPosY2;
  
  /** Les images des animations des bus */
  private Image arrowDown;
  private Image arrowUp;
  private Image arrowLeft;
  private Image arrowRight;
  private Image arrowDownBlue;
  private Image arrowUpBlue;
  private Image arrowLeftBlue;
  private Image arrowRightBlue;
  private Image arrowDownDarkBlue;
  private Image arrowUpDarkBlue;
  private Image arrowLeftDarkBlue;
  private Image arrowRightDarkBlue;
  private Image arrow2Down;
  private Image arrow3Down;
  private Image arrow4Down;
  private Image arrow5Down;
  
  private Image arrowDown640_480 = getToolkit().getImage("../Images/anim/640-480/DownArrow640-480.gif" );
  private Image arrowDown640_480Blue = getToolkit().getImage("../Images/anim/640-480/DownArrow640-480Blue.gif" );
  private Image arrowUp640_480 = getToolkit().getImage("../Images/anim/640-480/UpArrow640-480.gif" );
  private Image arrowUp640_480Blue = getToolkit().getImage("../Images/anim/640-480/UpArrow640-480Blue.gif" );
  private Image arrowLeft640_480 = getToolkit().getImage("../Images/anim/640-480/LeftArrow640-480.gif" );
  private Image arrowLeft640_480Blue = getToolkit().getImage("../Images/anim/640-480/LeftArrow640-480Blue.gif" );
  private Image arrowRight640_480 = getToolkit().getImage("../Images/anim/640-480/RightArrow640-480.gif" );
  private Image arrowRight640_480Blue = getToolkit().getImage("../Images/anim/640-480/RightArrow640-480Blue.gif" );
  private Image arrow2Down640_480 = getToolkit().getImage("../Images/anim/640-480/Down2Arrow640-480.gif" );
  private Image arrow3Down640_480 = getToolkit().getImage("../Images/anim/640-480/Down3Arrow640-480.gif" );
  private Image arrow4Down640_480 = getToolkit().getImage("../Images/anim/640-480/Down4Arrow640-480.gif" );
  private Image arrow5Down640_480 = getToolkit().getImage("../Images/anim/640-480/Down5Arrow640-480.gif" );
  
  private Image arrowDown800_600 = getToolkit().getImage("../Images/anim/800-600/DownArrow800-600.gif" );
  private Image arrowDown800_600Blue = getToolkit().getImage("../Images/anim/800-600/DownArrow800-600Blue.gif" );
  private Image arrowUp800_600 = getToolkit().getImage("../Images/anim/800-600/UpArrow800-600.gif" );
  private Image arrowUp800_600Blue = getToolkit().getImage("../Images/anim/800-600/UpArrow800-600Blue.gif" );
  private Image arrowLeft800_600 = getToolkit().getImage("../Images/anim/800-600/LeftArrow800-600.gif" );
  private Image arrowLeft800_600Blue = getToolkit().getImage("../Images/anim/800-600/LeftArrow800-600Blue.gif" );
  private Image arrowRight800_600 = getToolkit().getImage("../Images/anim/800-600/RightArrow800-600.gif" );
  private Image arrowRight800_600Blue = getToolkit().getImage("../Images/anim/800-600/RightArrow800-600Blue.gif" );
  private Image arrow2Down800_600 = getToolkit().getImage("../Images/anim/800-600/Down2Arrow800-600.gif" );
  private Image arrow3Down800_600 = getToolkit().getImage("../Images/anim/800-600/Down3Arrow800-600.gif" );
  private Image arrow4Down800_600 = getToolkit().getImage("../Images/anim/800-600/Down4Arrow800-600.gif" );
  private Image arrow5Down800_600 = getToolkit().getImage("../Images/anim/800-600/Down5Arrow800-600.gif" );
  
  private Image arrowDown1024_768 = getToolkit().getImage("../Images/anim/1024-768/DownArrow1024-768.gif" );
  private Image arrowDown1024_768Blue = getToolkit().getImage("../Images/anim/1024-768/DownArrow1024-768Blue.gif" );
  private Image arrowUp1024_768 = getToolkit().getImage("../Images/anim/1024-768/UpArrow1024-768.gif" );
  private Image arrowUp1024_768Blue = getToolkit().getImage("../Images/anim/1024-768/UpArrow1024-768Blue.gif" );
  private Image arrowLeft1024_768 = getToolkit().getImage("../Images/anim/1024-768/LeftArrow1024-768.gif" );
  private Image arrowLeft1024_768Blue = getToolkit().getImage("../Images/anim/1024-768/LeftArrow1024-768Blue.gif" );
  private Image arrowRight1024_768 = getToolkit().getImage("../Images/anim/1024-768/RightArrow1024-768.gif" );
  private Image arrowRight1024_768Blue = getToolkit().getImage("../Images/anim/1024-768/RightArrow1024-768Blue.gif" );
  private Image arrow2Down1024_768 = getToolkit().getImage("../Images/anim/1024-768/Down2Arrow1024-768.gif" );
  private Image arrow3Down1024_768 = getToolkit().getImage("../Images/anim/1024-768/Down3Arrow1024-768.gif" );
  private Image arrow4Down1024_768 = getToolkit().getImage("../Images/anim/1024-768/Down4Arrow1024-768.gif" );
  private Image arrow5Down1024_768 = getToolkit().getImage("../Images/anim/1024-768/Down5Arrow1024-768.gif" );
  
  private Image regPic;
  private Image regPicBlue;
  private Image regPicDarkBlue;
  private Image memPic;
  private Image memPicBlue;
  private Image memPicDarkBlue;
  private Image ualPic;
  private Image regIPic;
  private Image cptPic;
  private Image cptPlusPic;
  private Image radmPic;
  private Image radmPicBlue;
  private Image radmPicDarkBlue;
  
  private Image radm640_480 = getToolkit().getImage("../Images/anim/640-480/Radm640-480.gif" );
  private Image radm640_480Blue = getToolkit().getImage("../Images/anim/640-480/Radm640-480Blue.gif" );
  private Image cpt640_480 = getToolkit().getImage("../Images/anim/640-480/Cpt640-480.gif" );
  private Image cptPlus640_480 = getToolkit().getImage("../Images/anim/640-480/CptPlus640-480.gif" );
  private Image regI640_480 = getToolkit().getImage("../Images/anim/640-480/RegI640-480.gif" );
  private Image reg640_480 = getToolkit().getImage("../Images/anim/640-480/Reg640-480.gif" );
  private Image reg640_480Blue = getToolkit().getImage("../Images/anim/640-480/Reg640-480Blue.gif" );
  private Image mem640_480 = getToolkit().getImage("../Images/anim/640-480/Mem640-480.gif" );
  private Image mem640_480Blue = getToolkit().getImage("../Images/anim/640-480/Mem640-480Blue.gif" );
  private Image ual640_480 = getToolkit().getImage("../Images/anim/640-480/Ual640-480.gif" );
  
  private Image radm800_600 = getToolkit().getImage("../Images/anim/800-600/Radm800-600.gif" );
  private Image radm800_600Blue = getToolkit().getImage("../Images/anim/800-600/Radm800-600Blue.gif" );
  private Image cpt800_600 = getToolkit().getImage("../Images/anim/800-600/Cpt800-600.gif" );
  private Image cptPlus800_600 = getToolkit().getImage("../Images/anim/800-600/CptPlus800-600.gif" );
  private Image regI800_600 = getToolkit().getImage("../Images/anim/800-600/RegI800-600.gif" );
  private Image reg800_600 = getToolkit().getImage("../Images/anim/800-600/Reg800-600.gif" );
  private Image reg800_600Blue = getToolkit().getImage("../Images/anim/800-600/Reg800-600Blue.gif" );
  private Image mem800_600 = getToolkit().getImage("../Images/anim/800-600/Mem800-600.gif" );
  private Image mem800_600Blue = getToolkit().getImage("../Images/anim/800-600/Mem800-600Blue.gif" );
  private Image ual800_600 = getToolkit().getImage("../Images/anim/800-600/Ual800-600.gif" );
  
  private Image radm1024_768 = getToolkit().getImage("../Images/anim/1024-768/Radm1024-768.gif" );
  private Image radm1024_768Blue = getToolkit().getImage("../Images/anim/1024-768/Radm1024-768Blue.gif" );
  private Image cpt1024_768 = getToolkit().getImage("../Images/anim/1024-768/Cpt1024-768.gif" );
  private Image cptPlus1024_768 = getToolkit().getImage("../Images/anim/1024-768/CptPlus1024-768.gif" );
  private Image regI1024_768 = getToolkit().getImage("../Images/anim/1024-768/RegI1024-768.gif" );
  private Image reg1024_768 = getToolkit().getImage("../Images/anim/1024-768/Reg1024-768.gif" );
  private Image reg1024_768Blue = getToolkit().getImage("../Images/anim/1024-768/Reg1024-768Blue.gif" );
  private Image mem1024_768 = getToolkit().getImage("../Images/anim/1024-768/Mem1024-768.gif" );
  private Image mem1024_768Blue = getToolkit().getImage("../Images/anim/1024-768/Mem1024-768Blue.gif" );
  private Image ual1024_768 = getToolkit().getImage("../Images/anim/1024-768/Ual1024-768.gif" );
  
  /** Les positions des images des flches  des bus */
  private int arrow1UpX;
  private int arrow1UpY;
  private int arrow1DownX;
  private int arrow1DownY;
  private int arrow2UpX;
  private int arrow2UpY;
  private int arrow2DownX;
  private int arrow2DownY;
  private int arrow3UpX;
  private int arrow3UpY;
  private int arrow3DownX;
  private int arrow3DownY;
  private int arrowB3RegX;
  private int arrowB3RegY;
  private int arrowRegB1X;
  private int arrowRegB1Y;
  private int arrowRegB2X;
  private int arrowRegB2Y;
  private int arrowB1MemX;
  private int arrowB1MemY;
  private int arrowB2MemX;
  private int arrowB2MemY;
  private int arrowMemB3X;
  private int arrowMemB3Y;
  private int arrowB1UalX;
  private int arrowB1UalY;
  private int arrowB2UalX;
  private int arrowB2UalY;
  private int arrowUalB3X;
  private int arrowUalB3Y;
  private int arrowRegIB2X;
  private int arrowRegIB2Y;
  private int arrowRadmB1X;
  private int arrowRadmB1Y;
  private int arrowB3CptX;
  private int arrowB3CptY;
  private int arrowCptPlusCptX;
  private int arrowCptPlusCptY;
  private int arrowCptB1X;
  private int arrowCptB1Y;
  private int arrowB3RegIX;
  private int arrowB3RegIY;
  private int arrowB3RadmX;
  private int arrowB3RadmY;
  private int arrowB3Cpt2X;
  private int arrowB3Cpt2Y;
  
  /** Les positions des images */
  private int regX;
  private int ualX;
  private int memX;
  private int radmX;
  private int cptX;
  private int cptPlusX;
  private int regY;
  private int ualY;
  private int memY;
  private int radmY;
  private int cptY;
  private int regIX;
  private int regIY;
  private int cptPlusY;
  
  /** Des positions temporaires pour les animations */
  private int tmpX1;
  private int tmpX2;
  private int tmpX;
  private int tmpY1;
  private int tmpY2;
  private int tmpY;
  private int tmpX1Lim;
  private int tmpX2Lim;
  private int tmpXLim;
  private int tmpY1Lim;
  private int tmpY2Lim;
  private int tmpYLim;
  
  /** Le timer qui commande la vitesse de l'excution */
  private Timer delai;
  
  /** L'image de l'architecture */
  private JLabel image;
  
  /** Le compteur de programmes */
  private String mPC = "0";
  private String mNextPC = "0";
  
  /** L'opration de l'UAL */
  private String ual = "\u2205";
  
  /** L'tat des registres */
  private String regA = "-";
  private String regB = "-";
  private String regC = "-";
  
  /** Le constructeur */
  public Visual( UIArchi inArchiInterface )
  {
    super();
    mArchiInterface = inArchiInterface;
    image = inArchiInterface.getImageLabel();
    add( image );
    setForeground( new Color(102,102,153) );
  }
  
  /** praffichage des images */
  public void showAllpics()
  {
    if (!sLock)
    {
      try {
        sLock=true;
        mGraphic = image.getGraphics();
        Thread.sleep(500 );
    
        mGraphic.drawImage( arrowDown1024_768,-1,-1,this );
        mGraphic.drawImage( arrowDown1024_768Blue,-1,-1,this );
        mGraphic.drawImage( arrowUp1024_768 ,-1,-1,this );
        mGraphic.drawImage( arrowUp1024_768Blue ,-1,-1,this );
        mGraphic.drawImage( arrowLeft1024_768,-1,-1,this );
        mGraphic.drawImage( arrowLeft1024_768Blue,-1,-1,this );
        mGraphic.drawImage( arrowRight1024_768,-1,-1,this );
        mGraphic.drawImage( arrowRight1024_768Blue,-1,-1,this );
        mGraphic.drawImage(  arrow2Down1024_768,-1,-1,this );
        mGraphic.drawImage( arrow3Down1024_768,-1,-1,this );
        mGraphic.drawImage( arrow4Down1024_768,-1,-1,this );
        mGraphic.drawImage( arrow5Down1024_768,-1,-1,this );
        mGraphic.drawImage( radm1024_768 ,-1,-1,this );
        mGraphic.drawImage( radm1024_768Blue ,-1,-1,this );
        mGraphic.drawImage( cpt1024_768 ,-1,-1,this );
        mGraphic.drawImage( cptPlus1024_768,-1,-1,this );
        mGraphic.drawImage( regI1024_768 ,-1,-1,this );
        mGraphic.drawImage( reg1024_768 ,-1,-1,this );
        mGraphic.drawImage( reg1024_768Blue ,-1,-1,this );
        mGraphic.drawImage( mem1024_768 ,-1,-1,this );
        mGraphic.drawImage( mem1024_768Blue ,-1,-1,this );
        mGraphic.drawImage( ual1024_768 ,-1,-1,this );
        Thread.sleep(500 );
        mGraphic.drawImage( arrowDown800_600,-1,-1,this );
        mGraphic.drawImage( arrowDown800_600Blue,-1,-1,this );
        mGraphic.drawImage( arrowUp800_600 ,-1,-1,this );
        mGraphic.drawImage( arrowUp800_600Blue ,-1,-1,this );
        mGraphic.drawImage( arrowLeft800_600,-1,-1,this );
        mGraphic.drawImage( arrowLeft800_600Blue,-1,-1,this );
        mGraphic.drawImage( arrowRight800_600,-1,-1,this );
        mGraphic.drawImage( arrowRight800_600Blue,-1,-1,this );
        mGraphic.drawImage(  arrow2Down800_600,-1,-1,this );
        mGraphic.drawImage( arrow3Down800_600,-1,-1,this );
        mGraphic.drawImage( arrow4Down800_600,-1,-1,this );
        mGraphic.drawImage( arrow5Down800_600,-1,-1,this );
        mGraphic.drawImage( radm800_600 ,-1,-1,this );
        mGraphic.drawImage( radm800_600Blue ,-1,-1,this );
        mGraphic.drawImage( cpt800_600 ,-1,-1,this );
        mGraphic.drawImage( cptPlus800_600,-1,-1,this );
        mGraphic.drawImage( regI800_600 ,-1,-1,this );
        mGraphic.drawImage( reg800_600 ,-1,-1,this );
        mGraphic.drawImage( reg800_600Blue ,-1,-1,this );
        mGraphic.drawImage( mem800_600 ,-1,-1,this );
        mGraphic.drawImage( mem800_600Blue ,-1,-1,this );
        mGraphic.drawImage( ual800_600 ,-1,-1,this );
        Thread.sleep(500 );
        mGraphic.drawImage( arrowDown640_480,-1,-1,this );
        mGraphic.drawImage( arrowDown640_480Blue,-1,-1,this );
        mGraphic.drawImage( arrowUp640_480 ,-1,-1,this );
        mGraphic.drawImage( arrowUp640_480Blue ,-1,-1,this );
        mGraphic.drawImage( arrowLeft640_480,-1,-1,this );
        mGraphic.drawImage( arrowLeft640_480Blue,-1,-1,this );
        mGraphic.drawImage( arrowRight640_480,-1,-1,this );
        mGraphic.drawImage( arrowRight640_480Blue,-1,-1,this );
        mGraphic.drawImage(  arrow2Down640_480,-1,-1,this );
        mGraphic.drawImage( arrow3Down640_480,-1,-1,this );
        mGraphic.drawImage( arrow4Down640_480,-1,-1,this );
        mGraphic.drawImage( arrow5Down640_480,-1,-1,this );
        mGraphic.drawImage( radm640_480 ,-1,-1,this );
        mGraphic.drawImage( radm640_480Blue ,-1,-1,this );
        mGraphic.drawImage( cpt640_480 ,-1,-1,this );
        mGraphic.drawImage( cptPlus640_480,-1,-1,this );
        mGraphic.drawImage( regI640_480 ,-1,-1,this );
        mGraphic.drawImage( reg640_480 ,-1,-1,this );
        mGraphic.drawImage( reg640_480Blue ,-1,-1,this );
        mGraphic.drawImage( mem640_480 ,-1,-1,this );
        mGraphic.drawImage( mem640_480Blue ,-1,-1,this );
        mGraphic.drawImage( ual640_480 ,-1,-1,this );
        
        Thread.sleep(500 );
      }
      catch(InterruptedException e)
      {
        System.out.println("Attention, problme au chargement des images de l'animation !" );
      }
    }
  }
  
  
  /**
   * La fonction d'initialisation du timer
   * @param inTimer : le timer
   */
  public void setTimer( Timer inTimer ) { delai = inTimer; }
  
  /**
   * La fonction des mise a jour du compteur
   * @param inPC : le compteur
   */
  public void setDrawingPC( int inPC ) { mNextPC = String.valueOf( inPC ); }
  
  /**
   * La fonction des mise a jour du compteur
   * @param i : le compteur
   */
  private void majCpt() { if (mIsAnimated) image.repaint(mPCBoxSize1X+mXOffset,mPCBoxSize1Y+mYOffset,mPCBoxSize2X-mPCBoxSize1X,mPCBoxSize2Y-mPCBoxSize1Y ); }
  
  /**
   * La fonction des mise a jour de l'ual
   * @param u : l'opration de l'ual
   */
  public void setUal( String u ) { ual = u; majUal(); }
  
  /**
   * La fonction des mise a jour de l'ual graphiquement
   * @param u : l'opration de l'ual
   */
  public void majUal() { if (mIsAnimated) image.repaint(mUALBoxSize1X+mXOffset,mUALBoxSize1Y+mYOffset,mUALBoxSize2X-mUALBoxSize1X,mUALBoxSize2Y-mUALBoxSize1Y ); }
  
  /**
   * La fonction des mise a jour du registre "A"
   * @param u : l'action sur le registre "A"
   */
  public void setRegA( String u ) { regA = u; /*??majRegA();*/ }
  
  /**
   * La fonction des mise a jour du registre "A"
   * @param u : l'action sur le registre "A"
   */
  public void majRegA() {
    if (mIsAnimated) image.repaint(mRegBoxSize1X+mXOffset,mRegBoxSize1Y+mYOffset,mRegBoxSize2X-mRegBoxSize1X,mRegBoxSize2Y-mRegBoxSize1Y-(2*mRegHeight) );
  }
  
  /**
   * La fonction des mise a jour du registre "B"
   * @param u : l'action sur le registre "B"
   */
  public void setRegB(String u) { regB=u; /*??majRegB();*/ }
  
  /**
   * La fonction des mise a jour du registre "B"
   * @param u : l'action sur le registre "B"
   */
  public void majRegB() {
    if (mIsAnimated) image.repaint(mRegBoxSize1X+mXOffset,mRegBoxSize1Y+mYOffset+mRegHeight,mRegBoxSize2X-mRegBoxSize1X,mRegBoxSize2Y-mRegBoxSize1Y-(2*mRegHeight) );
  }
  
  /**
   * La fonction des mise a jour du registre "C"
   * @param u : l'action sur le registre "C"
   */
  public void setRegC(String u) { regC = u; /*??majRegC();*/ }
  
  /**
   * La fonction des mise a jour du registre "C"
   * @param u : l'action sur le registre "C"
   */
  public void majRegC() {
    if (mIsAnimated) image.repaint(mRegBoxSize1X+mXOffset,mRegBoxSize1Y+mYOffset+(2*mRegHeight),mRegBoxSize2X-mRegBoxSize1X,mRegBoxSize2Y-mRegBoxSize1Y-(2*mRegHeight) );
  }
  
  
  /** Met a jour les affichages dans l'architecture */
  public void updateArchi()
  {
    mIsAnimated=true;
    mPC=mNextPC;
    majCpt();
    majUal();
    mIsAnimated=false;
  }
  
  /** Stoppe l'animation en cours */
  public void stopAnim()
  {
    mPC=mNextPC;
    majCpt();
    mAnimStates.clear();
    mIsAnimated=false;
  }
  
  /** Met a 0 le n d'animation */
  public void resetColor()
  {
    if ( mGraphic != null) mAnimColor = new Color(102,102,153 );
    arrowUp = arrowUpDarkBlue;
    arrowDown = arrowDownDarkBlue;
    arrowLeft = arrowLeftDarkBlue;
    arrowRight = arrowRightDarkBlue;
    memPic = memPicDarkBlue;
    radmPic = radmPicDarkBlue;
    regPic = regPicDarkBlue;
  }
  
  /** Methode qui dmarre les animations */
  public void startAnim()
  {
    if (mAnimStates.size()!=0)
    {
      mIsAnimated = true;
      int lCurrentAnimation = ((Integer)mAnimStates.elementAt( 0 )).intValue();
      mAnimStates.removeElementAt( 0 );
      switch( lCurrentAnimation )
      {
      case (PixConstants.BUS1ANIM):         startBus1Anim();       break;
      case (PixConstants.BUS2ANIM):         startBus2Anim();       break;
      case (PixConstants.BUS3ANIM):         startBus3Anim();       break;
      case (PixConstants.REGTOBUS1ANIM):    startRegBus1Anim();    break;
      case (PixConstants.REGTOBUS2ANIM):    startRegBus2Anim();    break;
      case (PixConstants.BUS3TOREGANIM):    startBus3RegAnim();    break;
      case (PixConstants.BUS1TOUALANIM):    startBus1UalAnim();    break;
      case (PixConstants.BUS2TOUALANIM):    startBus2UalAnim();    break;
      case (PixConstants.UALTOBUS3ANIM):    startUalBus3Anim();    break;
      case (PixConstants.BUS3TOREGIANIM):   startBus3RegIAnim();   break;
      case (PixConstants.REGITOBUS2ANIM):   startRegIBus2Anim();   break;
      case (PixConstants.BUS3TOCPTANIM):    startBus3CptAnim();    break;
      case (PixConstants.CPTTOBUS1ANIM):    startCptBus1Anim();    break;
      case (PixConstants.CPTTOCPTPLUSANIM): startCptCptPlusAnim(); break;
      case (PixConstants.CPTPLUSTOCPTANIM): startCptPlusCptAnim(); break;
      case (PixConstants.BUS3TORADMANIM):   startBus3RadmAnim();   break;
      case (PixConstants.RADMTOBUS1ANIM):   startRadmBus1Anim();   break;
      case (PixConstants.BUS1TOMEMANIM):    startBus1MemAnim();    break;
      case (PixConstants.BUS2TOMEMANIM):    startBus2MemAnim();    break;
      case (PixConstants.MEMTOBUS3ANIM):    startMemBus3Anim();    break;
      
      default:System.out.println("Attention erreur inattendue!" ); break;
      }
    }
    else
      mArchiInterface.continueExec();
  }
  
  /** La fonction qui dbute l'animation du bus 1 */
  public void startBus1Anim()
  {
    mAnimState = PixConstants.BUS1ANIM;
    mGraphic = image.getGraphics();
    tmpX1 = bus1PosX1;
    tmpX2 = bus1PosX2;
    tmpY1 = (bus1PosY1+bus1PosY2)/2;
    tmpY2 = (bus1PosY1+bus1PosY2)/2;
    tmpY1Lim = bus1PosY1;
    tmpY2Lim = bus1PosY2;
    delai.restart();
  }
  
  /** La fonction qui anime le bus 1 */
  public void bus1Anim()
  {
    mGraphic.setColor( mAnimColor );
    mGraphic.fillRect( tmpX1 + mXOffset, tmpY1 + mYOffset, tmpX2 - tmpX1, 10 );
    mGraphic.fillRect( tmpX1 + mXOffset, tmpY2 + mYOffset, tmpX2 - tmpX1, 10 );
    if ( tmpY1 >= tmpY1Lim) { tmpY1 -= 10; }
    if ( tmpY2 <= tmpY2Lim) { tmpY2 += 10; }
    if ( tmpY1 <  tmpY1Lim) { mGraphic.drawImage(arrowUp,arrow1UpX+mXOffset,arrow1UpY+mYOffset,this ); }
    if ( tmpY2 > tmpY2Lim ) { mGraphic.drawImage(arrowDown,arrow1DownX+mXOffset,arrow1DownY+mYOffset,this ); }
    if ( tmpY1>=tmpY1Lim || tmpY2<=tmpY2Lim) { delai.restart(); }
    else { startAnim(); }
  }
  
  /** La fonction qui dbute l'animation du bus 2 */
  public void startBus2Anim()
  {
    mAnimState = PixConstants.BUS2ANIM;
    mGraphic = image.getGraphics();
    tmpX1 = bus2PosX1;
    tmpX2 = bus2PosX2;
    tmpY1 = (bus2PosY1+bus2PosY2)/2;
    tmpY2 = (bus2PosY1+bus2PosY2)/2;
    tmpY1Lim = bus2PosY1;
    tmpY2Lim = bus2PosY2;
    delai.restart();
  }
  
  /** La fonction qui anime le bus 2 */
  public void bus2Anim()
  {
    mGraphic.setColor(mAnimColor );
    mGraphic.fillRect( tmpX1 + mXOffset, tmpY1 + mYOffset, tmpX2 - tmpX1, 10 );
    mGraphic.fillRect( tmpX1 + mXOffset, tmpY2 + mYOffset, tmpX2 - tmpX1, 10 );
    if (tmpY1>=tmpY1Lim) { tmpY1-=10; }
    if (tmpY2<=tmpY2Lim) { tmpY2+=10; }
    if (tmpY1<tmpY1Lim) { mGraphic.drawImage(arrowUp,arrow2UpX+mXOffset,arrow2UpY+mYOffset,this ); }
    if (tmpY2>tmpY2Lim) { mGraphic.drawImage(arrowDown,arrow2DownX+mXOffset,arrow2DownY+mYOffset,this ); }
    if (tmpY1>=tmpY1Lim || tmpY2<=tmpY2Lim) { delai.restart(); }
    else { startAnim(); }
  }
  
  
  /** La fonction qui dbute l'animation du bus 3 */
  public void startBus3Anim()
  {
    mAnimState = PixConstants.BUS3ANIM;
    mGraphic = image.getGraphics();
    tmpX1 = bus3PosX1;
    tmpX2 = bus3PosX2;
    tmpY1 = (bus3PosY1+bus3PosY2)/2;
    tmpY2 = (bus3PosY1+bus3PosY2)/2;
    tmpY1Lim = bus3PosY1;
    tmpY2Lim = bus3PosY2;
    delai.restart();
  }
  
  /** La fonction qui anime le bus 3 */
  public void bus3Anim()
  {
    mGraphic.setColor( mAnimColor );
    mGraphic.fillRect( tmpX1 + mXOffset, tmpY1 + mYOffset, tmpX2 - tmpX1, 10 );
    mGraphic.fillRect( tmpX1 + mXOffset, tmpY2 + mYOffset, tmpX2 - tmpX1, 10 );
    if ( tmpY1 >= tmpY1Lim) { tmpY1 -= 10; }
    if ( tmpY2 <= tmpY2Lim) { tmpY2 += 10; }
    if ( tmpY1 < tmpY1Lim) { mGraphic.drawImage(arrowUp,arrow3UpX+mXOffset,arrow3UpY+mYOffset,this ); }
    if (tmpY2>tmpY2Lim) { mGraphic.drawImage(arrowDown,arrow3DownX+mXOffset,arrow3DownY+mYOffset,this ); }
    if (tmpY1>=tmpY1Lim || tmpY2<=tmpY2Lim) { delai.restart(); }
    else { startAnim(); }
  }
  
  /** La fonction qui fait l'animation du bus 3 au registres */
  public void startBus3RegAnim()
  {
    mAnimState=PixConstants.BUS3TOREGANIM;
    mGraphic=image.getGraphics();
    tmpX=bus3RegPosX2-5;
    tmpY1=bus3RegPosY1;
    tmpY2=bus3RegPosY2;
    tmpXLim=bus3RegPosX1;
    delai.restart();
  }
  
  /** La fonction qui fait l'animation du bus 3 au registres */
  public void bus3RegAnim()
  {
    mGraphic.setColor(mAnimColor );
    mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
    if ( tmpX >= tmpXLim ) { tmpX -= 5; }
    if ( tmpX < tmpXLim )
    {
      mGraphic.drawImage(arrowLeft,arrowB3RegX+mXOffset,arrowB3RegY+mYOffset,this );
      mGraphic.drawImage(regPic,regX+mXOffset,regY+mYOffset,this );
    }
    if ( tmpX >= tmpXLim ) { delai.restart(); }
    else
    {
      majRegA();
      majRegB();
      majRegC();
      startAnim();
    }
  }
  
  /** La fonction qui dbute l'animation du registres au bus 2 */
  public void startRegBus2Anim()
  {
    mAnimState=PixConstants.REGTOBUS2ANIM;
    mGraphic=image.getGraphics();
    tmpX=regBus2PosX2-5;
    tmpY1=regBus2PosY1;
    tmpY2=regBus2PosY2;
    tmpXLim=regBus2PosX1;
    majRegA();
    majRegB();
    majRegC();
    delai.restart();
  }
  
  /** La fonction qui fait l'animation du registres au bus2 */
  public void regBus2Anim()
  {
    if (tmpX==regBus2PosX2-5)
    {
      mGraphic.drawImage(regPic,regX+mXOffset,regY+mYOffset,this );
      mGraphic.setColor(mAnimColor );
    }
    mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
    if (tmpX>=tmpXLim) { tmpX-=5; }
    if (tmpX<tmpXLim) { mGraphic.drawImage(arrowLeft,arrowRegB2X+mXOffset,arrowRegB2Y+mYOffset,this ); }
    if (tmpX>=tmpXLim) { delai.restart(); }
    else { startAnim(); }
  }
  
  
  
  /** La fonction qui dbute l'animation du registres au bus 1 */
  public void startRegBus1Anim()
  {
    mAnimState=PixConstants.REGTOBUS1ANIM;
    mGraphic=image.getGraphics();
    tmpX=regBus1PosX2-5;
    tmpY1=regBus1PosY1;
    tmpY2=regBus1PosY2;
    tmpXLim=regBus1PosX1;
    majRegA();
    majRegB();
    majRegC();
    delai.restart();
  }
  
  /** La fonction qui fait l'animation du registres au bus1 */
  public void regBus1Anim()
  {
    if (tmpX==regBus1PosX2-5)
    {
      mGraphic.drawImage(regPic,regX+mXOffset,regY+mYOffset,this );
      mGraphic.setColor(mAnimColor );
    }
    mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
    if (tmpX>=tmpXLim) { tmpX-=5; }
    if (tmpX<tmpXLim) { mGraphic.drawImage(arrowLeft,arrowRegB1X+mXOffset,arrowRegB1Y+mYOffset,this ); }
    if (tmpX>=tmpXLim) { delai.restart(); }
    else { startAnim(); }
  }
  
  
  
  /** La fonction qui dbute l'animation du bus 1 a la memoire */
  public void startBus1MemAnim()
  {
    mAnimState=PixConstants.BUS1TOMEMANIM;
    mGraphic=image.getGraphics();
    tmpX=bus1MemPosX1;
    tmpY1=bus1MemPosY1;
    tmpY2=bus1MemPosY2;
    tmpXLim=bus1MemPosX2;
    delai.restart();
  }
  
  /** La fonction qui fait l'animation du bus 1 a la memoire */
  public void bus1MemAnim()
  {
    mGraphic.setColor(mAnimColor );
    mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
    if (tmpX<=tmpXLim) { tmpX+=5; }
    if (tmpX>tmpXLim)
    {
    mGraphic.drawImage(arrowRight,arrowB1MemX+mXOffset,arrowB1MemY+mYOffset,this );
    mGraphic.drawImage(memPic,memX+mXOffset,memY+mYOffset,this );
    }
    if (tmpX<=tmpXLim)
    { delai.restart();
    }
    else { startAnim();
    }
  }
  
  /** La fonction qui dbute l'animation du bus 2 a la memoire */
  public void startBus2MemAnim()
  {
  mAnimState=PixConstants.BUS2TOMEMANIM;
  mGraphic=image.getGraphics();
  tmpX=bus2MemPosX1;
  tmpY1=bus2MemPosY1;
  tmpY2=bus2MemPosY2;
  tmpXLim=bus2MemPosX2;
  delai.restart();
  }
  
  /** La fonction qui fait l'animation du bus 2 a la memoire */
  public void bus2MemAnim()
  {
  
  mGraphic.setColor(mAnimColor );
  mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
  if (tmpX<=tmpXLim) { tmpX+=5; }
  if (tmpX>tmpXLim)
  {
  mGraphic.drawImage(arrowRight,arrowB2MemX+mXOffset,arrowB2MemY+mYOffset,this );
  mGraphic.drawImage(memPic,memX+mXOffset,memY+mYOffset,this );
  }
  if (tmpX<=tmpXLim)
  { delai.restart();
  }
  else { startAnim();
  }
  }
  
  /** La fonction qui dbute l'animation de la memoire au bus 3 */
  public void startMemBus3Anim()
  {
  mAnimState=PixConstants.MEMTOBUS3ANIM;
  mGraphic=image.getGraphics();
  tmpX=memBus3PosX1;
  tmpY1=memBus3PosY1;
  tmpY2=memBus3PosY2;
  tmpXLim=memBus3PosX2;
  delai.restart();
  }
  
  /** La fonction qui fait l'animation  de la memoire au bus 3 */
  public void memBus3Anim()
  {
  if (tmpX==memBus3PosX1)
  {
  mGraphic.drawImage(memPic,memX+mXOffset,memY+mYOffset,this );
  mGraphic.setColor(mAnimColor );
  }
  mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
  if (tmpX<=tmpXLim) { tmpX+=5; }
  if (tmpX>tmpXLim)
  { mGraphic.drawImage(arrowRight,arrowMemB3X+mXOffset,arrowMemB3Y+mYOffset,this );
  }
  if (tmpX<=tmpXLim)
  { delai.restart();
  }
  else { startAnim();
  }
  }
  
  
  
  /** La fonction qui dbute l'animation de l'ual au bus 3 */
  public void startUalBus3Anim()
  {
  mAnimState=PixConstants.UALTOBUS3ANIM;
  mGraphic=image.getGraphics();
  tmpX=ualBus3PosX1;
  tmpY1=ualBus3PosY1;
  tmpY2=ualBus3PosY2;
  tmpXLim=ualBus3PosX2;
  delai.restart();
  }
  
  /** La fonction qui fait l'animation  de l'ual au bus 3 */
  public void ualBus3Anim()
  {
  if (tmpX==ualBus3PosX1)
  {
  mGraphic.drawImage(ualPic,ualX+mXOffset,ualY+mYOffset,this );
  mGraphic.setColor(mAnimColor );
  }
  mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
  if (tmpX<=tmpXLim) { tmpX+=5; }
  if (tmpX>tmpXLim)
  { mGraphic.drawImage(arrowRight,arrowUalB3X+mXOffset,arrowUalB3Y+mYOffset,this );
  }
  if (tmpX<=tmpXLim)
  { delai.restart();
  }
  else { startAnim();
  }
  }
  
  
  /** La fonction qui dbute l'animation du bus 1 a l'ual */
  public void startBus1UalAnim()
  {
  mAnimState=PixConstants.BUS1TOUALANIM;
  mGraphic=image.getGraphics();
  tmpX=bus1UalPosX1;
  tmpY1=bus1UalPosY1;
  tmpY2=bus1UalPosY2;
  tmpXLim=bus1UalPosX2;
  delai.restart();
  }
  
  /** La fonction qui fait l'animation du bus 1 a l'ual */
  public void bus1UalAnim()
  {
  
  mGraphic.setColor(mAnimColor );
  mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
  if (tmpX<=tmpXLim) { tmpX+=5; }
  if (tmpX>tmpXLim)
  {
  mGraphic.drawImage(arrowRight,arrowB1UalX+mXOffset,arrowB1UalY+mYOffset,this );
  mGraphic.drawImage(ualPic,ualX+mXOffset,ualY+mYOffset,this );
  }
  if (tmpX<=tmpXLim)
  { delai.restart();
  }
  else { startAnim();
  }
  }
  
  /** La fonction qui dbute l'animation du bus 2  a l'ual  */
  public void startBus2UalAnim()
  {
  mAnimState=PixConstants.BUS2TOUALANIM;
  mGraphic=image.getGraphics();
  tmpX=bus2UalPosX1;
  tmpY1=bus2UalPosY1;
  tmpY2=bus2UalPosY2;
  tmpXLim=bus2UalPosX2;
  delai.restart();
  }
  
  /** La fonction qui fait l'animation du bus 2  a l'ual */
  public void bus2UalAnim()
  {
  
  mGraphic.setColor(mAnimColor );
  mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
  if (tmpX<=tmpXLim) { tmpX+=5; }
  if (tmpX>tmpXLim)
  {
  mGraphic.drawImage(arrowRight,arrowB2UalX+mXOffset,arrowB2UalY+mYOffset,this );
  mGraphic.drawImage(ualPic,ualX+mXOffset,ualY+mYOffset,this );
  }
  if (tmpX<=tmpXLim)
  { delai.restart();
  }
  else { startAnim();
  }
  }
  
  /** La fonction qui fait l'animation du bus3 au registre d'instructions */
  public void startBus3RegIAnim()
  {
  mAnimState=PixConstants.BUS3TOREGIANIM;
  mGraphic=image.getGraphics();
  tmpX=bus3RegIPosX2-5;
  tmpY1=bus3RegIPosY1;
  tmpY2=bus3RegIPosY2;
  tmpXLim=bus3RegIPosX1;
  delai.restart();
  }
  
  /** La fonction qui fait l'animation du bus3 au registre d'instructions */
  public void bus3RegIAnim()
  {
  
  mGraphic.setColor(mAnimColor );
  mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
  if (tmpX>=tmpXLim) { tmpX-=5; }
  if (tmpX<tmpXLim)
  {
  mGraphic.drawImage(arrow3Down,arrowB3RegIX+mXOffset,arrowB3RegIY+mYOffset,this );
  mGraphic.drawImage(regIPic,regIX+mXOffset,regIY+mYOffset,this );
  }
  if (tmpX>=tmpXLim)
  { delai.restart();
  }
  else { startAnim();
  }
  }
  
  /** La fonction qui fait l'animation du registre d'instructions au bus2 */
  public void startRegIBus2Anim()
  {
  mAnimState=PixConstants.REGITOBUS2ANIM;
  mGraphic=image.getGraphics();
  tmpX=regIBus2PosX2-5;
  tmpY1=regIBus2PosY1;
  tmpY2=regIBus2PosY2;
  tmpXLim=regIBus2PosX1;
  delai.restart();
  }
  
  /** La fonction qui fait l'animation du registre d'instructions au bus2 */
  public void regIBus2Anim()
  {
  if (tmpX==regIBus2PosX2-5)
  {
  mGraphic.drawImage(regIPic,regIX+mXOffset,regIY+mYOffset,this );
  mGraphic.setColor(mAnimColor );
  }
  mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
  if (tmpX>=tmpXLim) { tmpX-=5; }
  if (tmpX<tmpXLim)
  {
  mGraphic.drawImage(arrowLeft,arrowRegIB2X+mXOffset,arrowRegIB2Y+mYOffset,this );
  }
  if (tmpX>=tmpXLim)
  { delai.restart();
  }
  else { startAnim();
  }
  }
  
  /** La fonction qui fait l'animation du bus3 au radm */
  public void startBus3RadmAnim()
  {
  mAnimColor=new Color(102,102,153 );
  mAnimState=PixConstants.BUS3TORADMANIM;
  mGraphic=image.getGraphics();
  tmpX=bus3RadmPosX2-5;
  tmpY1=bus3RadmPosY1;
  tmpY2=bus3RadmPosY2;
  tmpXLim=bus3RadmPosX1;
  delai.restart();
  }
  
  /** La fonction qui fait l'animation du bus3 au radm */
  public void bus3RadmAnim()
  {
  
  mGraphic.setColor(mAnimColor );
  mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
  if (tmpX>=tmpXLim) { tmpX-=5; }
  if (tmpX<tmpXLim)
  {
  mGraphic.drawImage(arrow4Down,arrowB3RadmX+mXOffset,arrowB3RadmY+mYOffset,this );
  mGraphic.drawImage(radmPic,radmX+mXOffset,radmY+mYOffset,this );
  }
  if (tmpX>=tmpXLim)
  { delai.restart();
  }
  else
  {
  mAnimColor=new Color(168,168,253 );
  arrowUp=arrowUpBlue;
  arrowDown=arrowDownBlue;
  arrowLeft=arrowLeftBlue;
  arrowRight=arrowRightBlue;
  memPic=memPicBlue;
  radmPic=radmPicBlue;
  regPic=regPicBlue;
  startAnim();
  }
  }
  
  /** La fonction qui fait l'animation du radm au bus1 */
  public void startRadmBus1Anim()
  {
  mAnimState=PixConstants.RADMTOBUS1ANIM;
  mGraphic=image.getGraphics();
  tmpX=radmBus1PosX2-5;
  tmpY1=radmBus1PosY1;
  tmpY2=radmBus1PosY2;
  tmpXLim=radmBus1PosX1;
  delai.restart();
  }
  
  /** La fonction qui fait l'animation du radm au bus1 */
  public void radmBus1Anim()
  {
  if (tmpX==radmBus1PosX2-5)
  {
  mGraphic.drawImage(radmPic,radmX+mXOffset,radmY+mYOffset,this );
  mGraphic.setColor(mAnimColor );
  }
  mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
  if (tmpX>=tmpXLim) { tmpX-=5; }
  if (tmpX<tmpXLim)
  {
  mGraphic.drawImage(arrowLeft,arrowRadmB1X+mXOffset,arrowRadmB1Y+mYOffset,this );
  }
  if (tmpX>=tmpXLim)
  { delai.restart();
  }
  else { startAnim();
  }
  }
  
  
  /** La fonction qui fait l'animation du bus3 au cpt */
  public void startBus3CptAnim()
  {
  mAnimState=PixConstants.BUS3TOCPTANIM;
  mGraphic=image.getGraphics();
  tmpX=bus3CptPosX2-5;
  tmpY1=bus3CptPosY1;
  tmpY2=bus3CptPosY2;
  tmpXLim=bus3CptPosX1;
  delai.restart();
  }
  
  /** La fonction qui fait l'animation du bus3 au cpt */
  public void bus3CptAnim()
  {
  
  mGraphic.setColor(mAnimColor );
  mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
  if (tmpX>=tmpXLim) { tmpX-=5; }
  if (tmpX<tmpXLim)
  {
  mGraphic.drawImage(arrow2Down,arrowB3CptX+mXOffset,arrowB3CptY+mYOffset,this );
  mGraphic.drawImage(arrow5Down,arrowB3Cpt2X+mXOffset,arrowB3Cpt2Y+mYOffset,this );
  mGraphic.drawImage(cptPic,cptX+mXOffset,cptY+mYOffset,this );
  mPC=mNextPC;
  majCpt();
  }
  if (tmpX>=tmpXLim)
  { delai.restart();
  }
  else
  {
  majCpt();
  startAnim();
  }
  }
  
  
  /** La fonction qui fait l'animation du mPC au bus2 */
  public void startCptBus1Anim()
  {
  mAnimState=PixConstants.CPTTOBUS1ANIM;
  mGraphic=image.getGraphics();
  tmpX=cptBus1PosX2-5;
  tmpY1=cptBus1PosY1;
  tmpY2=cptBus1PosY2;
  tmpXLim=cptBus1PosX1;
  delai.restart();
  }
  
  /** La fonction qui fait l'animation du cpt au bus2 */
  public void cptBus1Anim()
  {
  if (tmpX==cptBus1PosX2-5)
  {
  mGraphic.drawImage(cptPic,cptX+mXOffset,cptY+mYOffset,this );
  mGraphic.setColor(mAnimColor );
  }
  mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
  if (tmpX>=tmpXLim) { tmpX-=5; }
  if (tmpX<tmpXLim)
  {
  mGraphic.drawImage(arrowLeft,arrowCptB1X+mXOffset,arrowCptB1Y+mYOffset,this );
  }
  if (tmpX>=tmpXLim)
  { delai.restart();
  }
  else { startAnim();
  }
  }
  
  /** La fonction qui dbute l'animation du +2 au cpt */
  public void startCptPlusCptAnim()
  {
  mAnimState=PixConstants.CPTPLUSTOCPTANIM;
  mGraphic=image.getGraphics();
  tmpX=cptPlusCptPosX1;
  tmpY1=cptPlusCptPosY1;
  tmpY2=cptPlusCptPosY2;
  tmpXLim=cptPlusCptPosX2;
  delai.restart();
  }
  
  /** La fonction qui fait l'animation du +2 au cpt */
  public void cptPlusCptAnim()
  {
  
  mGraphic.setColor(mAnimColor );
  mGraphic.fillRect(tmpX+mXOffset,tmpY1+mYOffset,5,tmpY2-tmpY1 );
  if (tmpX<=tmpXLim) { tmpX+=5; }
  if (tmpX>tmpXLim)
  {
  mGraphic.drawImage(arrow2Down,arrowCptPlusCptX+mXOffset,arrowCptPlusCptY+mYOffset,this
  );
  mGraphic.drawImage(arrow5Down,arrowB3Cpt2X+mXOffset,arrowB3Cpt2Y+mYOffset,this );
  mGraphic.drawImage(cptPic,cptX+mXOffset,cptY+mYOffset,this );
  mPC=mNextPC;
  majCpt();
  }
  if (tmpX<=tmpXLim)
  { delai.restart();
  }
  else
  {
  majCpt();
  startAnim();
  }
  }
  
  
  /** La fonction qui dbute l'animation du cpt au +2 */
  public void startCptCptPlusAnim()
  {
  mAnimState=PixConstants.CPTTOCPTPLUSANIM;
  mGraphic=image.getGraphics();
  tmpX1=cptCptPlusPosX1;
  tmpX2=cptCptPlusPosX2;
  tmpY2=cptCptPlusPosY2;
  tmpY=cptCptPlusPosY2;
  tmpYLim=cptCptPlusPosY1;
  delai.restart();
  }
  
  /** La fonction qui anime le bus du cpt au +2 */
  public void cptCptPlusAnim()
  {
  mGraphic.setColor(mAnimColor );
  mGraphic.fillRect(tmpX1+mXOffset,tmpY+mYOffset,tmpX2-tmpX1,5 );
  
  if (tmpY>=tmpYLim) { tmpY-=5; }
  if (tmpY<tmpYLim) { mGraphic.drawImage(cptPlusPic,cptPlusX+mXOffset,cptPlusY+mYOffset,this );
  }
  if (tmpY>=tmpYLim)
  { delai.restart();
  }
  else { startAnim();
  }
  }

  /**
  *  Met a jour les positions des infos aprs changement de rsolution
  *  @param w : la largeur de la fentre
  *  @param w : la hauteur de la fentre
  */
  public void setMode(int w, int h)
  {
  stopAnim();
  if (w==640 && h==480)
  {
  
  mPCBoxPosX=177;mPCBoxPosY=236;
  mUALBoxPosX=140;mUALBoxPosY=111;
  mRegBoxPosX=110;mRegBoxPosY=51;mRegHeight=11;
  
  mPCBoxSize1X=174;mPCBoxSize1Y=227;
  mUALBoxSize1X=133;mUALBoxSize1Y=97;
  mRegBoxSize1X=110;mRegBoxSize1Y=39;
  mPCBoxSize2X=193;mPCBoxSize2Y=237;
  mUALBoxSize2X=170;mUALBoxSize2Y=115;
  mRegBoxSize2X=190;mRegBoxSize2Y=75;
  
  
  arrowUpBlue=arrowUp640_480Blue;
  arrowUpDarkBlue=arrowUp640_480;
  arrowUp=arrowUpDarkBlue;
  arrowDownBlue=arrowDown640_480Blue;
  arrowDownDarkBlue=arrowDown640_480;
  arrowDown=arrowDownDarkBlue;
  arrow2Down=arrow2Down640_480;
  arrow3Down=arrow3Down640_480;
  arrow4Down=arrow4Down640_480;
  arrow5Down=arrow5Down640_480;
  arrowLeftBlue=arrowLeft640_480Blue;
  arrowLeftDarkBlue=arrowLeft640_480;
  arrowLeft=arrowLeftDarkBlue;
  arrowRightBlue=arrowRight640_480Blue;
  arrowRightDarkBlue=arrowRight640_480;
  arrowRight=arrowRightDarkBlue;
  
  
  memPicBlue=mem640_480Blue;
  memPicDarkBlue=mem640_480;
  memPic=memPicDarkBlue;
  memX=104;
  memY=301;
  cptPic=cpt640_480;
  cptX=104;
  cptY=224;
  cptPlusPic=cptPlus640_480;
  cptPlusX=71;
  cptPlusY=183;
  ualPic=ual640_480;
  ualX=104;
  ualY=83;
  regPicBlue=reg640_480Blue;
  regPicDarkBlue=reg640_480;
  regPic=regPicDarkBlue;
  regX=104;
  regY=26;
  regIPic=regI640_480;
  regIX=104;
  regIY=151;
  radmPicBlue=radm640_480Blue;
  radmPicDarkBlue=radm640_480;
  radmPic=radmPicDarkBlue;
  radmX=104;
  radmY=271;
  
  bus1PosX1=25;bus1PosX2=30;bus1PosY1=25;bus1PosY2=330;
  bus2PosX1=53;bus2PosX2=58;bus2PosY1=25;bus2PosY2=330;
  bus3PosX1=252;bus3PosX2=257;bus3PosY1=25;bus3PosY2=330;
  
  bus3RegPosX1=201;bus3RegPosX2=252;bus3RegPosY1=40;bus3RegPosY2=45;
  regBus2PosX1=64;regBus2PosX2=105;regBus2PosY1=34;regBus2PosY2=39;
  regBus1PosX1=36;regBus1PosX2=106;regBus1PosY1=46;regBus1PosY2=51;
  bus1MemPosX1=28;bus1MemPosX2=93;bus1MemPosY1=307;bus1MemPosY2=312;
  bus2MemPosX1=56;bus2MemPosX2=93;bus2MemPosY1=321;bus2MemPosY2=326;
  memBus3PosX1=194;memBus3PosX2=240;memBus3PosY1=314;memBus3PosY2=319;
  bus1UalPosX1=29;bus1UalPosX2=93;bus1UalPosY1=94;bus1UalPosY2=99;
  bus2UalPosX1=56;bus2UalPosX2=93;bus2UalPosY1=115;bus2UalPosY2=120;
  ualBus3PosX1=194;ualBus3PosX2=240;ualBus3PosY1=102;ualBus3PosY2=107;
  bus3RegIPosX1=149;bus3RegIPosX2=254;bus3RegIPosY1=132;bus3RegIPosY2=137;
  regIBus2PosX1=65;regIBus2PosX2=155;regIBus2PosY1=171;regIBus2PosY2=176;
  
  bus3RadmPosX1=145;bus3RadmPosX2=254;bus3RadmPosY1=254;bus3RadmPosY2=259;
  radmBus1PosX1=36;radmBus1PosX2=154;radmBus1PosY1=291;radmBus1PosY2=296;
  
  
  bus3CptPosX1=155;bus3CptPosX2=256;bus3CptPosY1=189;bus3CptPosY2=193;
  cptBus1PosX1=38;cptBus1PosX2=155;cptBus1PosY1=244;cptBus1PosY2=249;
  
  cptCptPlusPosX1=84;cptCptPlusPosX2=90;cptCptPlusPosY1=208;cptCptPlusPosY2=244;
  cptPlusCptPosX1=99;cptPlusCptPosX2=146;cptPlusCptPosY1=189;cptPlusCptPosY2=193;
  
  arrow1UpX=21;arrow1UpY=14;arrow1DownX=21;arrow1DownY=329;
  arrow2UpX=49;arrow2UpY=14;arrow2DownX=49;arrow2DownY=329;
  arrow3UpX=248;arrow3UpY=14;arrow3DownX=248;arrow3DownY=329;
  arrowB3RegX=195;arrowB3RegY=36;
  arrowRegB2X=58;arrowRegB2Y=30;
  arrowRegB1X=30;arrowRegB1Y=42;
  arrowB1MemX=94;arrowB1MemY=303;
  arrowB2MemX=94;arrowB2MemY=317;
  arrowMemB3X=241;arrowMemB3Y=310;
  arrowB1UalX=94;arrowB1UalY=90;
  arrowB2UalX=94;arrowB2UalY=111;
  arrowUalB3X=241;arrowUalB3Y=98;
  arrowRegIB2X=58;arrowRegIB2Y=167;
  arrowRadmB1X=30;arrowRadmB1Y=287;
  arrowCptB1X=30;arrowCptB1Y=240;
  arrowB3CptX=153;arrowB3CptY=193;
  arrowCptPlusCptX=139;arrowCptPlusCptY=193;
  arrowB3RegIX=145;arrowB3RegIY=137;
  arrowB3RadmX=145;arrowB3RadmY=259;
  arrowB3Cpt2X=142;arrowB3Cpt2Y=205;
  
  }
  else if (w==800 && h==600)
  {
  
  mPCBoxPosX=223;mPCBoxPosY=305;
  mUALBoxPosX=183;mUALBoxPosY=148;
  mRegBoxPosX=144;mRegBoxPosY=73;mRegHeight=14;
  
  mPCBoxSize1X=213;mPCBoxSize1Y=293;
  mUALBoxSize1X=175;mUALBoxSize1Y=130;
  mRegBoxSize1X=140;mRegBoxSize1Y=59;
  mPCBoxSize2X=247;mPCBoxSize2Y=307;
  mUALBoxSize2X=224;mUALBoxSize2Y=154;
  mRegBoxSize2X=246;mRegBoxSize2Y=105;
  
  
  arrowUpBlue=arrowUp800_600Blue;
  arrowUpDarkBlue=arrowUp800_600;
  arrowUp=arrowUpDarkBlue;
  arrowDownBlue=arrowDown800_600Blue;
  arrowDownDarkBlue=arrowDown800_600;
  arrowDown=arrowDownDarkBlue;
  arrow2Down=arrow2Down800_600;
  arrow3Down=arrow3Down800_600;
  arrow4Down=arrow4Down800_600;
  arrow5Down=arrow5Down800_600;
  arrowLeftBlue=arrowLeft800_600Blue;
  arrowLeftDarkBlue=arrowLeft800_600;
  arrowLeft=arrowLeftDarkBlue;
  arrowRightBlue=arrowRight800_600Blue;
  arrowRightDarkBlue=arrowRight800_600;
  arrowRight=arrowRightDarkBlue;
  
  
  memPicBlue=mem800_600Blue;
  memPicDarkBlue=mem800_600;
  memPic=memPicDarkBlue;
  memX=136;
  memY=386;
  cptPic=cpt800_600;
  cptX=136;
  cptY=290;
  cptPlusPic=cptPlus800_600;
  cptPlusX=94;
  cptPlusY=239;
  ualPic=ual800_600;
  ualX=136;
  ualY=114;
  regPicBlue=reg800_600Blue;
  regPicDarkBlue=reg800_600;
  regPic=regPicDarkBlue;
  regX=136;
  regY=42;
  regIPic=regI800_600;
  regIX=136;
  regIY=199;
  radmPicBlue=radm800_600Blue;
  radmPicDarkBlue=radm800_600;
  radmPic=radmPicDarkBlue;
  radmX=136;
  radmY=349;
  
  bus1PosX1=26;bus1PosX2=32;bus1PosY1=30;bus1PosY2=432;
  bus2PosX1=61;bus2PosX2=67;bus2PosY1=30;bus2PosY2=432;
  bus3PosX1=332;bus3PosX2=338;bus3PosY1=30;bus3PosY2=432;
  bus3RegPosX1=260;bus3RegPosX2=333;bus3RegPosY1=60;bus3RegPosY2=66;
  regBus2PosX1=76;regBus2PosX2=136;regBus2PosY1=52;regBus2PosY2=58;
  regBus1PosX1=40;regBus1PosX2=136;regBus1PosY1=67;regBus1PosY2=73;
  bus1MemPosX1=31;bus1MemPosX2=124;bus1MemPosY1=394;bus1MemPosY2=400;
  bus2MemPosX1=66;bus2MemPosX2=124;bus2MemPosY1=411;bus2MemPosY2=417;
  memBus3PosX1=250;memBus3PosX2=319;memBus3PosY1=402;memBus3PosY2=408;
  bus1UalPosX1=31;bus1UalPosX2=124;bus1UalPosY1=127;bus1UalPosY2=133;
  bus2UalPosX1=66;bus2UalPosX2=124;bus2UalPosY1=154;bus2UalPosY2=160;
  ualBus3PosX1=249;ualBus3PosX2=320;ualBus3PosY1=139;ualBus3PosY2=145;
  bus3RegIPosX1=191;bus3RegIPosX2=332;bus3RegIPosY1=175;bus3RegIPosY2=181;
  regIBus2PosX1=78;regIBus2PosX2=199;regIBus2PosY1=224;regIBus2PosY2=230;
  bus3RadmPosX1=190;bus3RadmPosX2=332;bus3RadmPosY1=327;bus3RadmPosY2=334;
  radmBus1PosX1=40;radmBus1PosX2=198;radmBus1PosY1=374;radmBus1PosY2=380;
  bus3CptPosX1=201;bus3CptPosX2=332;bus3CptPosY1=245;bus3CptPosY2=251;
  cptBus1PosX1=43;cptBus1PosX2=199;cptBus1PosY1=315;cptBus1PosY2=321;
  cptCptPlusPosX1=111;cptCptPlusPosX2=117;cptCptPlusPosY1=270;cptCptPlusPosY2=315;
  cptPlusCptPosX1=130;cptPlusCptPosX2=189;cptPlusCptPosY1=245;cptPlusCptPosY2=251;
  
  arrow1UpX=21;arrow1UpY=15;arrow1DownX=21;arrow1DownY=429;
  arrow2UpX=56;arrow2UpY=15;arrow2DownX=56;arrow2DownY=429;
  arrow3UpX=327;arrow3UpY=15;arrow3DownX=327;arrow3DownY=429;
  arrowB3RegX=250;arrowB3RegY=55;
  arrowRegB2X=67;arrowRegB2Y=47;
  arrowRegB1X=32;arrowRegB1Y=62;
  arrowB1MemX=124;arrowB1MemY=389;
  arrowB2MemX=124;arrowB2MemY=406;
  arrowMemB3X=319;arrowMemB3Y=397;
  arrowB1UalX=124;arrowB1UalY=122;
  arrowB2UalX=124;arrowB2UalY=149;
  arrowUalB3X=319;arrowUalB3Y=134;
  arrowRegIB2X=67;arrowRegIB2Y=219;
  arrowRadmB1X=32;arrowRadmB1Y=369;
  arrowCptB1X=32;arrowCptB1Y=310;
  arrowB3CptX=197;arrowB3CptY=251;
  arrowCptPlusCptX=179;arrowCptPlusCptY=251;
  arrowB3RegIX=186;arrowB3RegIY=181;
  arrowB3RadmX=187;arrowB3RadmY=334;
  arrowB3Cpt2X=183;arrowB3Cpt2Y=266;
  
  }
  else if (w==1024 && h==768)
  {
  
  mPCBoxSize1X=280;mPCBoxSize1Y=392;
  mUALBoxSize1X=221;mUALBoxSize1Y=188;
  mRegBoxSize1X=180;mRegBoxSize1Y=100;
  mPCBoxSize2X=316;mPCBoxSize2Y=409;
  mUALBoxSize2X=283;mUALBoxSize2Y=214;
  mRegBoxSize2X=313;mRegBoxSize2Y=150;
  
  mPCBoxPosX=285;mPCBoxPosY=407;
  mUALBoxPosX=235;mUALBoxPosY=205;
  mRegBoxPosX=190;mRegBoxPosY=110;mRegHeight=17;
  
  arrowUpBlue=arrowUp1024_768Blue;
  arrowUpDarkBlue=arrowUp1024_768;
  arrowUp=arrowUpDarkBlue;
  arrowDownBlue=arrowDown1024_768Blue;
  arrowDownDarkBlue=arrowDown1024_768;
  arrowDown=arrowDownDarkBlue;
  arrow2Down=arrow2Down1024_768;
  arrow3Down=arrow3Down1024_768;
  arrow4Down=arrow4Down1024_768;
  arrow5Down=arrow5Down1024_768;
  arrowLeftBlue=arrowLeft1024_768Blue;
  arrowLeftDarkBlue=arrowLeft1024_768;
  arrowLeft=arrowLeftDarkBlue;
  arrowRightBlue=arrowRight1024_768Blue;
  arrowRightDarkBlue=arrowRight1024_768;
  arrowRight=arrowRightDarkBlue;
  
  
  memPicBlue=mem1024_768Blue;
  memPicDarkBlue=mem1024_768;
  memPic=memPicDarkBlue;
  memX=174;
  memY=512;
  cptPic=cpt1024_768;
  cptX=174;
  cptY=389;
  cptPlusPic=cptPlus1024_768;
  cptPlusX=120;
  cptPlusY=324;
  ualPic=ual1024_768;
  ualX=174;
  ualY=164;
  regPicBlue=reg1024_768Blue;
  regPicDarkBlue=reg1024_768;
  regPic=regPicDarkBlue;
  regX=174;
  regY=72;
  regIPic=regI1024_768;
  regIX=174;
  regIY=273;
  radmPicBlue=radm1024_768Blue;
  radmPicDarkBlue=radm1024_768;
  radmPic=radmPicDarkBlue;
  radmX=174;
  radmY=464;
  
  
  mPCBoxPosX=285;mPCBoxPosY=407;
  mUALBoxPosX=235;mUALBoxPosY=205;
  mRegBoxPosX=190;mRegBoxPosY=110;mRegHeight=17;
  
  bus1PosX1=31;bus1PosX2=39;bus1PosY1=40;bus1PosY2=580;
  bus2PosX1=75;bus2PosX2=83;bus2PosY1=40;bus2PosY2=580;
  bus3PosX1=429;bus3PosX2=437;bus3PosY1=40;bus3PosY2=580;
  bus3RegPosX1=334;bus3RegPosX2=429;bus3RegPosY1=93;bus3RegPosY2=101;
  regBus2PosX1=98;regBus2PosX2=175;regBus2PosY1=83;regBus2PosY2=91;
  regBus1PosX1=54;regBus1PosX2=175;regBus1PosY1=103;regBus1PosY2=111;
  bus1MemPosX1=37;bus1MemPosX2=156;bus1MemPosY1=521;bus1MemPosY2=529;
  bus2MemPosX1=81;bus2MemPosX2=156;bus2MemPosY1=543;bus2MemPosY2=551;
  memBus3PosX1=317;memBus3PosX2=411;memBus3PosY1=531;memBus3PosY2=539;
  bus1UalPosX1=37;bus1UalPosX2=157;bus1UalPosY1=179;bus1UalPosY2=187;
  bus2UalPosX1=81;bus2UalPosX2=157;bus2UalPosY1=214;bus2UalPosY2=222;
  ualBus3PosX1=317;ualBus3PosX2=412;ualBus3PosY1=195;ualBus3PosY2=203;
  bus3RegIPosX1=243;bus3RegIPosX2=429;bus3RegIPosY1=241;bus3RegIPosY2=249;
  regIBus2PosX1=97;regIBus2PosX2=253;regIBus2PosY1=303;regIBus2PosY2=311;
  
  bus3RadmPosX1=243;bus3RadmPosX2=429;bus3RadmPosY1=435;bus3RadmPosY2=444;
  radmBus1PosX1=54;radmBus1PosX2=252;radmBus1PosY1=495;radmBus1PosY2=503;
  
  
  bus3CptPosX1=255;bus3CptPosX2=432;bus3CptPosY1=330;bus3CptPosY2=338;
  cptBus1PosX1=54;cptBus1PosX2=254;cptBus1PosY1=420;cptBus1PosY2=428;
  
  cptCptPlusPosX1=141;cptCptPlusPosX2=149;cptCptPlusPosY1=361;cptCptPlusPosY2=421;
  cptPlusCptPosX1=167;cptPlusCptPosX2=239;cptPlusCptPosY1=330;cptPlusCptPosY2=338;
  
  arrow1UpX=25;arrow1UpY=25;arrow1DownX=25;arrow1DownY=578;
  arrow2UpX=69;arrow2UpY=25;arrow2DownX=69;arrow2DownY=578;
  arrow3UpX=423;arrow3UpY=25;arrow3DownX=423;arrow3DownY=578;
  arrowB3RegX=319;arrowB3RegY=87;
  arrowRegB2X=83;arrowRegB2Y=77;
  arrowRegB1X=39;arrowRegB1Y=97;
  arrowB1MemX=156;arrowB1MemY=515;
  arrowB2MemX=156;arrowB2MemY=537;
  arrowMemB3X=411;arrowMemB3Y=525;
  arrowB1UalX=156;arrowB1UalY=173;
  arrowB2UalX=156;arrowB2UalY=208;
  arrowUalB3X=411;arrowUalB3Y=189;
  arrowRegIB2X=83;arrowRegIB2Y=297;
  arrowRadmB1X=39;arrowRadmB1Y=489;
  arrowCptB1X=39;arrowCptB1Y=414;
  arrowB3CptX=251;arrowB3CptY=338;
  arrowCptPlusCptX=228;arrowCptPlusCptY=338;
  arrowB3RegIX=238;arrowB3RegIY=249;
  arrowB3RadmX=238;arrowB3RadmY=444;
  arrowB3Cpt2X=234;arrowB3Cpt2Y=359;
  
  }
  repaint();
  }
  
  /** La methode paint recrite pour que toutes les infos s'affiche correctement */
  public void paint(Graphics mGraphic)
  {
  if (image!=null && image.getIcon()!=null)
  {
  int xD=getWidth()-((ImageIcon)image.getIcon()).getImage().getWidth(this );
  mXOffset=-1;
  int yD=getHeight()-((ImageIcon)image.getIcon()).getImage().getHeight(this );
  mYOffset=1;
  int hGap=Math.max(xD/2,0 );
  int vGap=Math.max(yD/2,0 );
  if (((FlowLayout)getLayout()).getHgap()!=hGap || ((FlowLayout)getLayout()).getVgap()!=vGap)
  {
  image.setLocation(hGap,vGap );
  setLayout(new FlowLayout(FlowLayout.LEADING,hGap,vGap) );
  }
  }
  super.paint(mGraphic );
  }
  
  
  /**
   * La methode paint recrite pour que toutes les infos s'affiche correctement
   * @param mGraphic : 
   */
  public void paintImage(Graphics mGraphic)
  {
    mGraphic.setColor(new Color(102,102,153) );
    mGraphic.drawString(regA,mRegBoxPosX+mXOffset,mRegBoxPosY+mYOffset );
    mGraphic.drawString(mPC,mPCBoxPosX+mXOffset,mPCBoxPosY+mYOffset );
    mGraphic.drawString(regC,mRegBoxPosX+mXOffset,mRegBoxPosY+mYOffset+2*mRegHeight );
    mGraphic.drawString(regB,mRegBoxPosX+mXOffset,mRegBoxPosY+mYOffset+mRegHeight );
    mGraphic.drawString(ual,mUALBoxPosX+mXOffset,mUALBoxPosY+mYOffset );
    mGraphic.setColor(mAnimColor );
  }

  /**
   * methode d'accs au champ mAnimState
   * @return l'etat de l'animation
   */
  public int getAnimState(){ return mAnimState; }
  
  /**
   *methode d'accs au champ mAnimStates
   *@return les animations a effectuer
   */
  protected Vector getAnimStates(){return mAnimStates;}
  
  /**
   *methode qui ajoute une animation a la liste
   *@return l'etat de l'animation
   */
  public void addAnimState(int anim){ mAnimStates.addElement(new Integer(anim) );
  }
}


