/**
 * La partie de l'interface  gerant la barre de commanedes.
 * Elle contient les boutons pilotant toute l'application ;
 *  savoir play,pause,stop,back,next,backstep,et nextstep.
 *
 * @version 1.0 19/03/00
 * @author Paul Ladeveze
 * @author Frederik Sackx
 */
package Interface.ICmd;

import javax.swing.*;
import java.awt.*;
import javax.accessibility.*;
import java.util.Vector;
import javax.swing.border.LineBorder;

import Utilitaires.GridUtils;
import Controlers.CmdControl;

public class UICmd extends JPanel

{
    /**
     * Le bouton play
     */
    private  JToggleButton play;
    /**
     * Le bouton pause
     */
    private  JToggleButton pause;
    /**
     * Le bouton stop
     */
    private  JToggleButton stop;
    /**
     * Le bouton instruction precedente
     */
    private  JButton back;
     /**
     * Le bouton instruction suivante
     */
    private  JButton next;
    /**
     * Le bouton de pas d'instruction precedent
     */
    private  JButton backStep;
    /**
     * Le bouton de pas d'instruction suivant
     */
    private  JButton nextStep;
     /**
     * Le bouton de choix de dlai d'excution
     */
    JButton timer;
     /**
     * Le groupe de boutons qui contiendra les boutons STOP, PLAY et PAUSE
     */
    ButtonGroup action = new ButtonGroup();

    /**
     * Les items de la Popup du choix de dlai
     */
    Vector itemVector=new Vector();


    /**
     * Le controleur de barre de commandes
     */

    /**
     * Le champ pour le timer
     */
    private JPopupMenu timerPopup=new JPopupMenu("Dlai d'excution" );

    private CmdControl control;

    /**
     * Les icones de la barre de commande
     */
    ImageIcon playIcon=new ImageIcon("../Images/icons/normal/play.gif" );
    ImageIcon pauseIcon=new ImageIcon("../Images/icons/normal/pause.gif" );
    ImageIcon backStepIcon=new ImageIcon("../Images/icons/normal/backstep.gif" );
    ImageIcon nextStepIcon=new ImageIcon("../Images/icons/normal/nextstep.gif" );
    ImageIcon backIcon=new ImageIcon("../Images/icons/normal/back.gif" );
    ImageIcon nextIcon=new ImageIcon("../Images/icons/normal/next.gif" );
    ImageIcon stopIcon=new ImageIcon("../Images/icons/normal/stop.gif" );
    ImageIcon timerIcon=new ImageIcon("../Images/icons/normal/watch.gif" );
    ImageIcon playMiniIcon=new ImageIcon("../Images/icons/mini/MiniPlay.gif" );
    ImageIcon pauseMiniIcon=new ImageIcon("../Images/icons/mini/MiniPause.gif" );
    ImageIcon backStepMiniIcon=new ImageIcon("../Images/icons/mini/MiniBackStep.gif" );
    ImageIcon nextStepMiniIcon=new ImageIcon("../Images/icons/mini/MiniNextStep.gif" );
    ImageIcon backMiniIcon=new ImageIcon("../Images/icons/mini/MiniBack.gif" );
    ImageIcon nextMiniIcon=new ImageIcon("../Images/icons/mini/MiniNext.gif" );
    ImageIcon stopMiniIcon=new ImageIcon("../Images/icons/mini/MiniStop.gif" );
    ImageIcon timerMiniIcon=new ImageIcon("../Images/icons/mini/MiniWatch.gif" );


    /**
     * Le constructeur
     */
    public UICmd()
    {

  super();

  JMenuItem item;
  for(int i=0;i<11;i+=1)
      {
    item=new JMenuItem(String.valueOf(i) );
    itemVector.addElement(item );
    timerPopup.add(item );
      }
  timerPopup.setBorder(LineBorder.createBlackLineBorder() );

  play = new JToggleButton("Play",playIcon,false );
  pause = new JToggleButton("Pause",pauseIcon,false );
  stop = new JToggleButton("Stop",stopIcon,true );
  action.add(play );
  action.add(stop );
  action.add(pause );
  back = new JButton("Back",backIcon );
  next = new JButton("Next",nextIcon );
  backStep = new JButton("Step",backStepIcon );
  nextStep = new JButton("Step",nextStepIcon );
  timer=new JButton("2",timerIcon );
  timer.setMargin(new Insets(0,0,0,0) );
  play.setToolTipText("Assemble et lance l'excution " );
  pause.setToolTipText("Arrete l'excution : play la relance du mme point" );
  stop.setToolTipText("Stoppe compltement l'excution " );
  back.setToolTipText("Recule  l'excution de l'instruction prcdente " );
  next.setToolTipText("Avance  l'excution de l'instruction suivante " );
  backStep.setToolTipText("Recule  l'excution du pas d'instruction prcdent " );
  nextStep.setToolTipText("Avance  l'excution du pas d'instruction suivant " );
  timer.setToolTipText("Change la vitesse d'excution des instructions " );

  GridBagLayout grille=new GridBagLayout();
  GridBagConstraints regles=new GridBagConstraints();

  setLayout(grille );
  regles.fill=GridBagConstraints.BOTH;
  regles.anchor=GridBagConstraints.CENTER;
  Insets interior=new Insets(1,1,1,1 );

  GridUtils.buildConstraints(regles,new Insets(0,0,0,0),0,0,0,0,1,1,8,100 );
  grille.setConstraints(timer,regles );
  timer.setPreferredSize(getPreferredSize() );
  add(timer );

  GridUtils.buildConstraints(regles,new Insets(0,0,0,0),0,0,1,0,1,1,15,100 );
  grille.setConstraints(back,regles );
  back.setPreferredSize(getPreferredSize() );
  add(back );

  GridUtils.buildConstraints(regles,new Insets(0,0,0,0),0,0,2,0,1,1,15,100 );
  grille.setConstraints(backStep,regles );
  backStep.setPreferredSize(getPreferredSize() );
  add(backStep );

  GridUtils.buildConstraints(regles,new Insets(0,0,0,0),0,0,3,0,1,1,15,100 );
  grille.setConstraints(stop,regles );
  stop.setPreferredSize(getPreferredSize() );
  add(stop );

  GridUtils.buildConstraints(regles,new Insets(0,0,0,0),0,0,4,0,1,1,15,100 );
  grille.setConstraints(play,regles );
  play.setPreferredSize(getPreferredSize() );
  add(play );

  GridUtils.buildConstraints(regles,new Insets(0,0,0,0),0,0,5,0,1,1,15,100 );
  grille.setConstraints(pause,regles );
  pause.setPreferredSize(getPreferredSize() );
  add(pause );

  GridUtils.buildConstraints(regles,new Insets(0,0,0,0),0,0,6,0,1,1,15,100 );
  grille.setConstraints(nextStep,regles );
  nextStep.setPreferredSize(getPreferredSize() );
  add(nextStep );

   GridUtils.buildConstraints(regles,new Insets(0,0,0,0),0,0,7,0,1,1,15,100 );
  grille.setConstraints(next,regles );
  next.setPreferredSize(getPreferredSize() );
  add(next );



       }

    /**
     * Change la police et les icones pour le mode 1024*768
     */
    public void setBigIcons()
    {
  Font fb = new Font("DIALOG",Font.PLAIN,14 );
  play.setDisabledIcon(playIcon );
  pause.setDisabledIcon(pauseIcon );
  stop.setDisabledIcon(stopIcon );
  back.setDisabledIcon(backIcon );
  next.setDisabledIcon(nextIcon );
  backStep.setDisabledIcon(backStepIcon );
  nextStep.setDisabledIcon(nextStepIcon );

  play.setIcon(playIcon );
  pause.setIcon(pauseIcon );
  stop.setIcon(stopIcon );
  back.setIcon(backIcon );
  next.setIcon(nextIcon );
  backStep.setIcon(backStepIcon );
  nextStep.setIcon(nextStepIcon );
  play.setFont(fb );
  pause.setFont(fb );
  stop.setFont(fb );
  back.setFont(fb );
  next.setFont(fb );
  backStep.setFont(fb );
  nextStep.setFont(fb );
  timer.setIcon(timerIcon );
  timer.setFont(fb );
  for(int k=0;k<itemVector.size();
k++)
      ((JMenuItem)itemVector.elementAt(k)).setFont(fb );
  timerPopup.setSize(timer.getWidth(),timerPopup.getHeight() );
    }


    /**
     * Change la police et les icones pour le mode 800*600
     */
    public void setMedIcons()
    {
  Font fb = new Font("DIALOG",Font.PLAIN,12 );
  play.setDisabledIcon(playIcon );
  pause.setDisabledIcon(pauseIcon );
  stop.setDisabledIcon(stopIcon );
  back.setDisabledIcon(backIcon );
  next.setDisabledIcon(nextIcon );
  backStep.setDisabledIcon(backStepIcon );
  nextStep.setDisabledIcon(nextStepIcon );

  play.setIcon(playIcon );
  pause.setIcon(pauseIcon );
  stop.setIcon(stopIcon );
  back.setIcon(backIcon );
  next.setIcon(nextIcon );
  backStep.setIcon(backStepIcon );
  nextStep.setIcon(nextStepIcon );
  play.setFont(fb );
  pause.setFont(fb );
  stop.setFont(fb );
  back.setFont(fb );
  next.setFont(fb );
  backStep.setFont(fb );
  nextStep.setFont(fb );
  timer.setIcon(timerIcon );
  timer.setFont(fb );
  for(int k=0;k<itemVector.size();
k++)
      ((JMenuItem)itemVector.elementAt(k)).setFont(fb );
  timerPopup.setSize(timer.getWidth(),timerPopup.getHeight() );
    }


    /**
     * Change la police et les icones pour le mode 640*480
     */
    public void setMiniIcons()
    {
  Font fp = new Font("DIALOG",Font.PLAIN,10 );
  play.setDisabledIcon(playMiniIcon );
  pause.setDisabledIcon(pauseMiniIcon );
  stop.setDisabledIcon(stopMiniIcon );
  back.setDisabledIcon(backMiniIcon );
  next.setDisabledIcon(nextMiniIcon );
  backStep.setDisabledIcon(backStepMiniIcon );
  nextStep.setDisabledIcon(nextStepMiniIcon );

  play.setIcon(playMiniIcon );
  pause.setIcon(pauseMiniIcon );
  stop.setIcon(stopMiniIcon );
  back.setIcon(backMiniIcon );
  next.setIcon(nextMiniIcon );
  backStep.setIcon(backStepMiniIcon );
  nextStep.setIcon(nextStepMiniIcon );
  play.setFont(fp );
  pause.setFont(fp );
  stop.setFont(fp );
  back.setFont(fp );
  next.setFont(fp );
  backStep.setFont(fp );
  nextStep.setFont(fp );
  timer.setIcon(timerMiniIcon );
  timer.setFont(fp );
  for(int k=0;k<itemVector.size();
k++)
      ((JMenuItem)itemVector.elementAt(k)).setFont(fp );
  timerPopup.setSize(timer.getWidth(),timerPopup.getHeight() );
    }


    /**
     * La methode definissant le controleur
     * @param cc : le controleur de commandes
    */
    public  void setControler(CmdControl cc)
    { control=cc;  }

    /**
     * La methode d'accescontroleur
     * @return  : le controleur de commandes
    */
    public CmdControl getControler()
    { return control;  }

    /**
     * La methode qui ajoute le controleur d'evenements aux composants voulus(ici les boutons)
     */
    public void setData()
    {
  control.createListener();
    }


    /**
     * La methode d'acces au bouton play
     *@return le bouton precite
     */
    public  JToggleButton getPlay(){ return play; }

    /**
     * La methode d'acces au bouton pause
     *@return le bouton precite
     */
    public  JToggleButton getPause(){return pause;}

    /**
     * La methode d'acces au bouton stop
     *@return le bouton precite
     */
    public  JToggleButton getStop(){return stop;}

    /**
     * La methode d'acces au groupe de boutons
     *@return le groupe de boutons boutons
     */
    public  ButtonGroup getAction(){return action;}

    /**
     * La methode d'acces au bouton back
     *@return le bouton precite
     */
    public  JButton getBack(){return back;}

    /**
     * La methode d'acces au bouton next
     *@return le bouton precite
     */
    public  JButton getNext(){return next;}

    /**
     * La methode d'acces au bouton backstep
     *@return le bouton precite
     */
    public  JButton getBackStep(){return backStep;}

    /**
     * La methode d'acces au bouton nextstep
     *@return le bouton precite
     */
    public  JButton getNextStep(){return nextStep;}

    /**
     * La methode d'acces au bouton dlai
     *@return le bouton de dlai
     */
    public JButton getTimer(){return timer;}

    /**
     * La methode d'acces au popup menu
     *@return le popup menu
     */
    public JPopupMenu getTimerPopup(){return timerPopup;}

    /**
     * La methode aux items du popup menu
     *@return un vecteur contenant des ItemMenu
     */
    public Vector getItemVector(){return itemVector;}
}
