package Interface.IEdit;

import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.util.*;
import java.io.File;
import java.io.Reader;
import java.io.StringReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.LineNumberReader;
import java.io.FileReader;

import Utilitaires.GridUtils;
import Controlers.EditControl;



/**
 *Classe implmentant un editeur externe pour PixArchi
 *
 * @version 1.0 19/03/00
 * @author Paul Ladeveze
 * @author Frederik Sackx
 */
public class EditExt extends JDialog
{

    /**
     * Le controleur d'edition
     */
    private EditControl control;

    private JTextPane texte;
    private JButton sauver;
    private JButton mLoadBtn;
    private JButton ok;
    private JButton cancel;
    private JLabel advert;



    /**
     * le constructeur
     */
    public EditExt(UIEdit ui,String txt)
    {

  super((JFrame)ui.getTopLevelAncestor(),"PixArchi: Editeur externe" );



  Font f = new Font("DIALOG",Font.PLAIN,10 );

  //Les boutons : sauver, charger que l'on met sur un JPanel buttonsPanel

  JPanel buttonsPanel=new JPanel();
  ImageIcon saveIcon=new ImageIcon("../Images/icons/normal/save.gif" );
  ImageIcon openIcon=new ImageIcon("../Images/icons/normal/open.gif" );
  ImageIcon helpIcon=new ImageIcon("../Images/icons/normal/help.gif" );
  sauver = new JButton("Sauvegarde",saveIcon );
  mLoadBtn = new JButton("Chargement",openIcon );
  sauver.setFont(f );
  mLoadBtn.setFont(f );
  mLoadBtn.setMargin(new Insets(0,0,0,0) );
  sauver.setMargin(new Insets(0,0,0,0) );
  GridBagLayout grilleButton=new GridBagLayout();
  GridBagConstraints reglesButton=new GridBagConstraints();

  buttonsPanel.setLayout(grilleButton );
  reglesButton.fill=GridBagConstraints.BOTH;
  reglesButton.anchor=GridBagConstraints.CENTER;
  Insets interiorButton=new Insets(0,0,0,0 );

  GridUtils.buildConstraints(reglesButton,interiorButton,0,0,0,0,1,1,15,100 );
  grilleButton.setConstraints(mLoadBtn,reglesButton );
  mLoadBtn.setPreferredSize(buttonsPanel.getPreferredSize() );
  buttonsPanel.add(mLoadBtn );

  GridUtils.buildConstraints(reglesButton,interiorButton,0,0,1,0,1,1,15,100 );
  grilleButton.setConstraints(sauver,reglesButton );
  sauver.setPreferredSize(buttonsPanel.getPreferredSize() );
  buttonsPanel.add(sauver );


  //Indication

  advert = new JLabel("Sparer les instructions par des Retour-Chariot !",JLabel.CENTER );
  advert.setFont(f );
  JPanel avertissement = new JPanel();
  avertissement.setLayout(new GridLayout(1,1) );
  avertissement.add(advert );

  //La JTextArea texte contenant le code assembleur

  texte=new JTextPane();
  texte.setPreferredSize(getPreferredSize() );
  texte.setMargin(new Insets(10,10,5,5) );
  texte.setFont( new Font("DIALOG",Font.PLAIN,12) );
  texte.setText(txt );

  JScrollPane scrollPane = new JScrollPane(texte );
  scrollPane.setPreferredSize(getContentPane().getPreferredSize() );


  //Les boutons : sauver, charger que l'on met sur un JPanel agreePanel

  JPanel agreePanel=new JPanel();
  ImageIcon okIcon=new ImageIcon("../Images/icons/normal/Ok.gif" );
  ImageIcon cancelIcon=new ImageIcon("../Images/icons/normal/Cancel.gif" );
  ok = new JButton("Ok",okIcon );
  cancel = new JButton("Annuler",cancelIcon );
  ok.setFont(f );
  cancel.setFont(f );
  ok.setMargin(new Insets(0,0,0,0) );
  cancel.setMargin(new Insets(0,0,0,0) );
  GridBagLayout grilleAgree=new GridBagLayout();
  GridBagConstraints reglesAgree=new GridBagConstraints();

  agreePanel.setLayout(grilleAgree );
  reglesAgree.fill=GridBagConstraints.BOTH;
  reglesAgree.anchor=GridBagConstraints.CENTER;
  Insets interiorAgree=new Insets(0,0,0,0 );

  GridUtils.buildConstraints(reglesAgree,interiorAgree,0,0,0,0,1,1,15,100 );
  grilleAgree.setConstraints(ok,reglesAgree );
  ok.setPreferredSize(agreePanel.getPreferredSize() );
  agreePanel.add(ok );

  GridUtils.buildConstraints(reglesAgree,interiorAgree,0,0,1,0,1,1,15,100 );
  grilleAgree.setConstraints(cancel,reglesAgree );
  cancel.setPreferredSize(agreePanel.getPreferredSize() );
  agreePanel.add(cancel );


  //L'aide a l'dition : couper, copier, coller

  JPanel helpPanel=new JPanel();
  JLabel raccourcis = new JLabel("Raccourcis :",JLabel.CENTER );
  JLabel couper = new JLabel("Couper : Ctrl-x",helpIcon,JLabel.LEFT );
  couper.setFont(f );
  couper.setVerticalAlignment(JLabel.BOTTOM );
  JLabel copier = new JLabel("Copier : Ctrl-c",helpIcon,JLabel.LEFT );
  copier.setFont(f );
  copier.setVerticalAlignment(JLabel.BOTTOM );
  JLabel coller = new JLabel("Coller : Ctrl-v",helpIcon,JLabel.LEFT );
  coller.setFont(f );
  coller.setVerticalAlignment(JLabel.BOTTOM );
  JLabel select = new JLabel("Select : Shift",helpIcon,JLabel.LEFT );
  select.setFont(f );
  select.setVerticalAlignment(JLabel.BOTTOM );
  JLabel selectbis = new JLabel("+direction",JLabel.RIGHT );
  selectbis.setFont(f );
  selectbis.setVerticalAlignment(JLabel.TOP );
  JLabel selectAll = new JLabel("SelectAll : Ctrl-a",helpIcon,JLabel.LEFT );
  selectAll.setFont(f );
  selectAll.setVerticalAlignment(JLabel.BOTTOM );
  helpPanel.setLayout(new GridLayout(7,1) );

  raccourcis.setPreferredSize(helpPanel.getPreferredSize() );
  helpPanel.add(raccourcis );
  couper.setPreferredSize(helpPanel.getPreferredSize() );
  helpPanel.add(couper );
  copier.setPreferredSize(helpPanel.getPreferredSize() );
  helpPanel.add(copier );
  coller.setPreferredSize(helpPanel.getPreferredSize() );
  helpPanel.add(coller );
  selectAll.setPreferredSize(helpPanel.getPreferredSize() );
  helpPanel.add(selectAll );
  select.setPreferredSize(helpPanel.getPreferredSize() );
  helpPanel.add(select );
  selectbis.setPreferredSize(helpPanel.getPreferredSize() );
  helpPanel.add(selectbis );


  //On place les boutons et le texte sur la fenetre

  GridBagLayout grille=new GridBagLayout();
  GridBagConstraints regles=new GridBagConstraints();

  getContentPane().setLayout(grille );
  regles.fill=GridBagConstraints.BOTH;
  regles.anchor=GridBagConstraints.CENTER;

  Insets interior=new Insets(1,1,1,1 );

  GridUtils.buildConstraints(regles,interior,0,0,0,0,2,1,100,5 );
  avertissement.setBorder(new SoftBevelBorder(SoftBevelBorder.RAISED) );
  grille.setConstraints(avertissement,regles );
  getContentPane().add(avertissement );

  GridUtils.buildConstraints(regles,interior,0,0,0,1,2,1,100,8 );
  buttonsPanel.setBorder(new SoftBevelBorder(SoftBevelBorder.RAISED) );
  grille.setConstraints(buttonsPanel,regles );
  getContentPane().add(buttonsPanel );

  GridUtils.buildConstraints(regles,interior,0,0,0,2,1,1,100,90 );
  scrollPane.setBorder(new SoftBevelBorder(SoftBevelBorder.RAISED) );
  grille.setConstraints(scrollPane,regles );
  getContentPane().add(scrollPane );

  GridUtils.buildConstraints(regles,interior,0,0,1,2,1,1,50,90 );
  helpPanel.setBorder(new SoftBevelBorder(SoftBevelBorder.RAISED) );
  grille.setConstraints(helpPanel,regles );
  getContentPane().add(helpPanel );

  GridUtils.buildConstraints(regles,interior,0,0,0,3,2,1,100,8 );
  agreePanel.setBorder(new SoftBevelBorder(SoftBevelBorder.RAISED) );
  grille.setConstraints(agreePanel,regles );
  getContentPane().add(agreePanel );


  //On donne sa taille a la fenetre et on la montre

  setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE );
  setSize(400,450 );
  setVisible( true );
  toFront();

    }



    /**
     * La methode qui definit le controleur
     * @ param ec : le controleur
     */
    public void setControler(EditControl ec)
    {  control=ec; }





    /**
     * La methode qui charge le contenu d'un fichier dans le tableau d'instructions
     * @param f : le inputReader contenant des instructions assembleur
     */
    public void charger(Reader f)
    {
  try
      {
    String contenu="";
    LineNumberReader file = new LineNumberReader(f );
    String str="";
    while ((str=file.readLine())!=null)
        {
      contenu+=str+"\n";
        }
    f.close();
    texte.setText(contenu );
;
      }
  catch (IOException e) {System.out.println("Erreur au chargement du fichier" );
}
    }



    /**
     * La methode qui sauve le contenu du tableau d'instructions dans un fichier
     * @param inFile : le fichier sous lequel sauver les instructions assembleur
     */
    public void sauver( File inFile ) {
      try {
        FileWriter lFile = new FileWriter( inFile );
        String lText = getText();
        lFile.write( lText );
        lFile.close();
      } catch (IOException e) { System.out.println("Erreur de sauvegarde du fichier" ); }
    }



    /**
     * La methode d'acces au bouton sauver
     * @return le bouton precite
     */
    public JButton getSaveBtn() { return sauver; }

    /**
     * La methode d'acces au bouton charger
     * @return le bouton precite
     */
    public JButton getLoadBtn()
    {return mLoadBtn;}



    /**
     * La methode d'acces au bouton ok
     * @return le bouton precite
     */
    public JButton getOk()
    {return ok;}



    /**
     * La methode d'acces au bouton cancel
     * @return le bouton precite
     */
    public JButton getCancel()
    {return cancel;}



    /**
     * La methode d'acces au texte
     * @return le texte contenant les instreuctions assembleur
     */
    public String getText()
    {return texte.getText();
}



}
