/**
 * La partie de l'interface  gerant les differents modeles: RAM,edition,architecture.
 * Elle represente la fenetre principale.
 *
 * @version 1.0 19/03/00
 * @author Paul Ladeveze
 * @author Frederik Sackx
 */
package Interface.IRam;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.accessibility.*;

import Utilitaires.*;

public class RamChoiceFrame extends JDialog

{
    /**
     * la liste des cases memoire
     */
    private JList listeCases;
    private JButton done=new JButton("Fini",new ImageIcon("../Images/icons/normal/Ok.gif") );
    private JButton cancel=new JButton("Annuler",new ImageIcon("../Images/icons/normal/Cancel.gif") );

    /**
     * Le constructeur
     */
    public RamChoiceFrame(UIRam ui)
    {

  super((JFrame)ui.getTopLevelAncestor(),"PixArchi: Choix des cases mmoires a voir" );

  Font f = new Font("DIALOG",Font.PLAIN,10 );

  done.setFont(f );
  cancel.setFont(f );

    setSize(380,450 );


  GridBagLayout grille=new GridBagLayout();
  GridBagConstraints regles=new GridBagConstraints();

  getContentPane().setLayout(grille );
  regles.fill=GridBagConstraints.BOTH;
  regles.anchor=GridBagConstraints.CENTER;

  Insets interior=new Insets(1,1,1,1 );

  createJList();
  JScrollPane scrollPane = new JScrollPane(listeCases );
  scrollPane.setBorder(new SoftBevelBorder(SoftBevelBorder.RAISED) );

  scrollPane.setPreferredSize(getContentPane().getPreferredSize() );


  ImageIcon helpI=new ImageIcon("../Images/icons/normal/help.gif" );
  JLabel aide1 = new JLabel(helpI,SwingConstants.LEFT );
  JLabel aide2 = new JLabel(helpI,SwingConstants.LEFT );
  aide1.setFont(new Font("Dialog",Font.PLAIN,10) );
  aide2.setFont(new Font("Dialog",Font.PLAIN,10) );
  aide1.setText(" CTRL  + CLICK pour slectionner plusieurs cases" );
  aide2.setText(" SHIFT + CLICK a 2 endroits pour faire une slection" );

  JPanel aidePanel=new JPanel();
  aidePanel.setLayout(new GridLayout(2,1) );
  aidePanel.add(aide1 );
  aidePanel.add(aide2 );

  aidePanel.setBorder(new SoftBevelBorder(SoftBevelBorder.RAISED) );
  GridUtils.buildConstraints(regles,interior,0,0,0,0,1,1,100,10 );
  grille.setConstraints(aidePanel,regles );
  getContentPane().add(aidePanel );


  GridUtils.buildConstraints(regles,interior,0,0,0,1,1,1,100,100 );
  grille.setConstraints(scrollPane,regles );
  getContentPane().add(scrollPane );


  JPanel buttonPanel=new JPanel();
  buttonPanel.setBorder(new SoftBevelBorder(SoftBevelBorder.RAISED) );
  buttonPanel.setLayout(new GridLayout(1,2) );
  done.setMargin(new Insets(0,0,0,0) );
  cancel.setMargin(new Insets(0,0,0,0) );
  buttonPanel.add(done );
  buttonPanel.add(cancel );


  GridUtils.buildConstraints(regles,interior,0,0,0,2,1,1,100,1 );
  grille.setConstraints(buttonPanel,regles );
  getContentPane().add(buttonPanel );


  setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE );
  setVisible( true );
    }
    /**
     * Une methode qui cree une liste des cases memoire
     * @see javax.swing.JList
     */
    private void createJList()
    {


  ListModel bigData = new AbstractListModel()
      {
    public int getSize() { return 65536; }
    public Object getElementAt(int index) { return "adresse: " + index; }
      };

  listeCases = new JList(bigData );
  listeCases.setPrototypeCellValue("adresse:  1234567890" );
  listeCases.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION );
  listeCases.setToolTipText("Allez-y! N'ayez pas peur de cliquer !! " );
  MouseListener mouseListener = new MouseAdapter()
      {
    public void mouseClicked(MouseEvent e)
    {
        if (e.getClickCount() == 2)
      {
          int index = listeCases.locationToIndex(e.getPoint() );
      }
    }
      };
  listeCases.addMouseListener(mouseListener );

    }

    /**
     * methode d'acces au bouton du meme nom
     * @return le bouton en question
     */
    public JButton getDone(){return done;}

    /**
     * methode d'acces au bouton du meme nom
     * @return le bouton en question
     */
    public JButton getCancel(){return cancel;}

    /**
     * methode d'acces a la liste des cases memoire
     * @return listeCases
     */
    public JList getListeCases(){return listeCases;}

}



