/**
 * La classe PRINCIPALE creant les differents objets necessaires
 *
 * @version 1.0 19/03/00
 * @author Paul Ladeveze
 * @author Frederik Sackx
 */

public class PixArchi
{
  public static void main( String [] args ) {
    /**
     * Le logo
     */
    Interface.UI.Logo logo = new Interface.UI.Logo();
    logo.toFront();

    /**
     * Le moteur du programme
     */
    Model.Engine lEngine = new Model.Engine();


    /**
     * L'interface du programme
     */
    Interface.UI.UI lInterface = new Interface.UI.UI();
    
    /**
     * Le controleur pour la barre de menu
     */
    Controlers.UIControl lMenuCtrl = new Controlers.UIControl( lEngine.getMEdit(), lInterface ) ;
    // on definit le controleur aupres de l'interface concernee
    lInterface.getMenu().setControler( lMenuCtrl );



    /**
     * Le controleur pour l'edition des programmes
     */
    Controlers.EditControl lEditCtrl = new Controlers.EditControl( lEngine.getMEdit(), lInterface.getUIEdit() );

    // on definit le controleur aupres de l'interface concernee
    lInterface.getUIEdit().setControler( lEditCtrl );

    // on definit le controleur aupres du modele concernee
    lEngine.getMEdit().setControler( lEditCtrl, lMenuCtrl );
    //on construit les objets qui avaient besoin du controleur avant leur creation
    lInterface.getUIEdit().setData();

    /**
     * Le controleur pour le timer du moteur
     */
    Controlers.EngineControl mc = new Controlers.EngineControl(lEngine );
    // on definit le controleur aupres de l'interface concernee
    lEngine.setControler( mc );

    // On construit les objets qui avaient besoin du controleur avant leur creation
    lEngine.setData();

    /**
     * Le controleur pour les registres
     */
    Controlers.RegControl lRegCtrl = new Controlers.RegControl( lEngine.getMReg(), lInterface.getUIReg() );

    // On definit le controleur aupres de l'interface concernee
    lInterface.getUIReg().setControler( lRegCtrl );
    // On definit le controleur aupres du modele concernee
    lEngine.getMReg().setControler( lRegCtrl );
    // On construit les objets qui avaient besoin du controleur avant leur creation
    lInterface.getUIReg().setData();

    /**
     *Le controleur pour la RAM
     */
    Controlers.RamControl lRamCtrl = new Controlers.RamControl( lEngine.getMRam(), lInterface.getUIRam(), lRegCtrl );

    // On definit le controleur aupres de l'interface concernee
    lInterface.getUIRam().setControler( lRamCtrl );
    // On definit le controleur aupres du modele concernee
    lEngine.getMRam().setControler( lRamCtrl );
    // On construit les objets qui avaient besoin du controleur avant leur creation
    lInterface.getUIRam().setData();

    /**
     *Le controleur pour les commandes(CMD)
     */
    Controlers.CmdControl  lCmdCtrl = new Controlers.CmdControl(lEngine,lInterface.getUICmd() );
    // on definit le controleur aupres de l'interface concernee
    lInterface.getUICmd().setControler( lCmdCtrl );
    // on definit le controleur aupres du modele concernee
    lEngine.getMCmd().setControler( lCmdCtrl );
    //on construit les objets qui avaient besoin du controleur avant leur creation
    lInterface.getUICmd().setData();

    /**
     *Le controleur pour l'architecture
     */
    Controlers.ArchiControl lArchiCtrl =
      new Controlers.ArchiControl( lEngine.getMArchi(), lInterface.getUIArchi() );

    // on definit le controleur aupres de l'interface concernee
    lInterface.getUIArchi().setControler( lArchiCtrl );
    // on definit le controleur aupres du modele concernee
    lEngine.getMArchi().setControler( lArchiCtrl );

    /**
     * On fait disparaitre le logo et on montre la fenetre
     */
    logo.setVisible( false );
    lInterface.setVisible( true );
    logo = null;
  }
}
