/**
 * Une classe reprsentant la fentre d'aide HTML
 *
 * @version 1.0 18/05/00
 * @author Paul Ladeveze
 * @author Frederik Sackx
 */
package Utilitaires;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.html.*;
import java.net.*;
import java.io.IOException;

public class HelpView extends JFrame implements HyperlinkListener
{
    /**
     * Le conteneur HTML
     */
    JEditorPane contenu;

    /**
     * le constructeur
     * @param lPath : l'url a ouvrir
     */
    public HelpView( String lPath )
    {

  super("PixArchi: Aide" );
  setSize(640,480 );
  try{
      URL myURL=new URL(lPath );

      try{
    contenu=new JEditorPane(myURL );

    contenu.setEditable(false );
    contenu.addHyperlinkListener(this );
    JScrollPane jsp=new JScrollPane(contenu,ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED );
    getContentPane().add(jsp );

      }catch (MalformedURLException m){  m.printStackTrace();
}
  }catch (IOException i){ i.printStackTrace();
}
    }

    public void hyperlinkUpdate(HyperlinkEvent e)
    {
  if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
      {
    JEditorPane pane = (JEditorPane) e.getSource();
    if (e instanceof HTMLFrameHyperlinkEvent)
        {
      HTMLFrameHyperlinkEvent  evt = (HTMLFrameHyperlinkEvent)e;
      HTMLDocument doc = (HTMLDocument)pane.getDocument();
      doc.processHTMLFrameHyperlinkEvent(evt );
        }
    else
        {
      try {
          pane.setPage(e.getURL() );
      } catch (Throwable t)
          {
          System.out.println("." );
      }
        }
      }
    }




}
