/**
 * Une classe regroupant des constantes utiles
 *
 * @version 1.0 19/03/00
 * @author Paul Ladeveze
 * @author Frederik Sackx
 */
package Utilitaires;


public class PixConstants
{
  /** Une constante codant pour le type d' affichage du contenu de la RAM en decimal */
  public static final int DECIMAL=0;
  /** Une constante codant pour le type d' affichage du contenu de la RAM en binaire(par defaut) */
  public static final int BINAIRE=1;
  /** Une constante codant pour le type d' affichage du contenu de la RAM en hexadecimal */
  public static final int HEXADECIMAL=2;

  /** Des constantes codant pour l'animation courante */
  public static final int BUS1ANIM=0;
  public static final int BUS2ANIM=1;
  public static final int BUS3ANIM=2;
  public static final int REGTOBUS1ANIM=3;
  public static final int REGTOBUS2ANIM=4;
  public static final int BUS3TOREGANIM=5;
  public static final int BUS1TOUALANIM=6;
  public static final int BUS2TOUALANIM=7;
  public static final int UALTOBUS3ANIM=8;
  public static final int BUS3TOREGIANIM=9;
  public static final int REGITOBUS2ANIM=10;
  public static final int BUS3TOCPTANIM=11;
  public static final int CPTTOBUS1ANIM=12;
  public static final int CPTTOCPTPLUSANIM=19;
  public static final int CPTPLUSTOCPTANIM=13;
  public static final int BUS3TORADMANIM=14;
  public static final int RADMTOBUS1ANIM=15;
  public static final int BUS1TOMEMANIM=16;
  public static final int BUS2TOMEMANIM=17;
  public static final int MEMTOBUS3ANIM=18;

  /** Des constantes pour le Rcc */
  public static final int RCCC=0;
  public static final int RCCZ=1;
  public static final int RCCN=2;
  public static final int RCCV=3;
  
  /** Une constante codant pour l'etat de l'execution */
  public static final int PLAY=1;

  /** Une constante codant pour l'etat de l'execution */
  public static final int PAUSE=2;

  /** Une constante codant pour l'etat de l'execution */
  public static final int STOP=3;

  // PixConstants pour la description du programme

  /** Format1 */
  public static final String FORMAT1="00";
  /** Format2 */
  public static final String FORMAT2="010";
  /** Format3 */
  public static final String FORMAT3="0110";
  /** Format4 */
  public static final String FORMAT4="100";
  /** Format5 */
  public static final String FORMAT5="1";
  /** Format6 */
  public static final String FORMAT6="1111";

  /** LIH */
  public static final String LIH="";
  /** B */
  public static final String B="0";
  /** BA */
  public static final String BA="1";
  /** BEQ */
  public static final String BEQ="000";
  /** BNE */
  public static final String BNE="001";
  /** BGE */
  public static final String BGE="010";
  /** BGT */
  public static final String BGT="011";
  /** BLE */
  public static final String BLE="100";
  /** BLT */
  public static final String BLT="101";
  /** BVS */
  public static final String BVS="100";
  /** BVC */
  public static final String BVC="101";
  /** ADD */
  public static final String ADD="0100";
  /** ADDPT */
  public static final String ADDPT="0101";
  /** SUB */
  public static final String SUB="0000";
  /** SUBPT */
  public static final String SUBPT="0001";
  /** ANDPT */
  public static final String ANDPT="0111";
  /** OR */
  public static final String OR="0110";
  /** LDX */
  public static final String LDX="1000";
  /** STX */
  public static final String STX="1001";
  /** LDBX */
  public static final String LDBX="1010";
  /** LDSBX */
  public static final String LDSBX="1101";
  /** STBX */
  public static final String STBX="1011";
  /** ADDI */
  public static final String ADDI="0100";
  /** ADDIPT */
  public static final String ADDIPT="0101";
  /** ANDIPT */
  public static final String ANDIPT="0111";
  /** ORI */
  public static final String ORI="0110";
  /** LD */
  public static final String LD="1000";
  /** ST */
  public static final String ST="1001";
  /** LDB */
  public static final String LDB="1010";
  /** LDSB */
  public static final String LDSB="1101";
  /** STB */
  public static final String STB="1011";
  /** LSL */
  public static final String LSL="00";
  /** ROL */
  public static final String ROL="01";
  /** LSR */
  public static final String LSR="10";
  /** ASR */
  public static final String ASR="11";
}
