package Utilitaires;

/**
 *Classe contenant un rsultat d'opration binaire : resultat + retenue
 */
public class Result
{
  /**
   * Le resultat
   */
  private String mResult;
  /**
   * La retenue
   */
  private int mCarry;
  /**
    * Le depassement de capacite
    */
  private int mOverFlow;
  
  /**
   * Le constructeur
   * @param res String
   * @param ret int
   */
  public Result( String inRes, int inCarry, int inOverFlow ) {
    mResult = inRes;
    mCarry = inCarry;
    mOverFlow = inOverFlow;
  }
  /**
   * Methode d'acces au resultat
   * @return la valeur du resulat (binary string)
   */
  public String getResult() { return mResult; }
  /**
   * Methode d'acces au resultat
   * @return la valeur du resulat (binary string)
   */
  public int getIntResult() { return Utils.signedBinToInt( mResult ); }
  /**
   * Methode d'acces a la retenue
   * @return la valeur de la retenue
   */
  public int getCarry() { return mCarry; }
  /**
    * Methode d'acces au depassement
    * @return la valeur du depassement
    */
  public int getOverFlow() { return mOverFlow; }
  /**
   * Methode d'acces au resultat
   * @param String
   */
  public void setResult( String inRes ) { mResult = inRes; }
  /**
   * Methode d'acces a la retenue
   * @param int
   */
  public void setCarry( int inCarry ) { mCarry = inCarry; }
  
}

