/**
 * Le tutorial (mode demonstration)
 * La classe qui permet de faire une dmonstration du logiciel PixArchi
 *
 * @version 1.0 19/03/00
 * @author Paul Ladeveze
 * @author Frederik Sackx
 */
package Utilitaires;

import javax.swing.*;
import java.awt.*;
import java.io.IOException;

import Controlers.*;
import Interface.UI.UI;


public class Tutorial extends JDialog
{

    /**
     * Variable contenant c qui doit tre affich
     */
    private JEditorPane info;

    /**
     * Les boutons quitter et suite
     */
    private JButton quit;
    private JButton ok;

    /**
     * La taille de police a utiliser
     */
    private int taille;

    /**
     * L'tape courante du tutorial
     */
    private int etape=0;

    /**
     * La mise en page de la fenetre
     */
    private GridBagLayout grille=new GridBagLayout();
    private GridBagConstraints regles=new GridBagConstraints();

    /**
     * L'image a suivre ...
     */
    private Image arrowleft = getToolkit().getImage("../Images/divers/flechegauche.gif" );
    private Image arrowright = getToolkit().getImage("../Images/divers/flechedroite.gif" );
    private Image arrowdown = getToolkit().getImage("../Images/divers/flechebas.gif" );
    private Image arrowup = getToolkit().getImage("../Images/divers/flechehaut.gif" );
    private Image imCour;
    private int imX;
    private int imY;

    private JPanel infoPanel;

    /**
     * L'interface principale du logiciel
     */
    UI inter;

    public Tutorial(UI ui,UIControl uc)
    {
  super(ui,"Tutorial" );

  inter=ui;

  setSize(ui.getWidth()/2,ui.getHeight()/2 );
  setLocation(ui.getLocationOnScreen().x+ui.getWidth()/4,ui.getLocationOnScreen().y+ui.getHeight()/4 );

  getContentPane().setLayout(grille );
  regles.fill=GridBagConstraints.BOTH;
  regles.anchor=GridBagConstraints.CENTER;
  Insets interior=new Insets( 1, 1, 1, 1 );

  quit = new JButton("Quitter",new ImageIcon("../Images/icons/normal/Cancel.gif") );
  quit.addActionListener(uc );
  ok = new JButton("Suite",new ImageIcon("../Images/icons/normal/Ok.gif") );
  ok.addActionListener(uc );
  switch (ui.getWidth())
      {
      case 640 :
    quit.setFont( new Font("DIALOG",Font.PLAIN,10) );
    ok.setFont( new Font("DIALOG",Font.PLAIN,10) );
    taille=1;
    break;
      case 800 :
    quit.setFont(new Font("DIALOG",Font.PLAIN,12) );
    ok.setFont(new Font("DIALOG",Font.PLAIN,12) );
    taille=2;
    break;
      case 1024 :
    quit.setFont(new Font("DIALOG",Font.PLAIN,14) );
    ok.setFont(new Font("DIALOG",Font.PLAIN,14) );
    taille=4;
    break;
      case 1152 :
    quit.setFont(new Font("DIALOG",Font.PLAIN,16) );
    ok.setFont(new Font("DIALOG",Font.PLAIN,16) );
    taille=4;
    break;
      default :
    quit.setFont(new Font("DIALOG",Font.PLAIN,16) );
    ok.setFont(new Font("DIALOG",Font.PLAIN,16) );
    taille=1;
    break;
      }

  String texte ="<CENTER>"
      +"<B><FONT SIZE="+taille+" COLOR=\"#FF0000\">Bienvenue en mode Demo</FONT></B>"
      +"<HR><BR><FONT SIZE="+taille+">"
      +"<BR>Pour commencer cette demo <BR>appuyez sur Suite"
      +"<BR><BR>Vous pourrez quitter a tout <BR>moment en appuyant sur Quitter"
      +"</CENTER></FONT>";
  info = new JEditorPane("text/html",texte );
  info.setEditable(false );
  info.setSize(getWidth(),getHeight() );
  infoPanel = new JPanel()
      {
    public void paint(Graphics g)
    {
        super.paint(g );
        if (g!=null && imCour!=null) g.drawImage(imCour,imX,imY,infoPanel );
    }
      };

  infoPanel.setBackground(Color.white );
  infoPanel.add(info );

  GridUtils.buildConstraints(regles,interior,0,0,0,0,2,1,100,100 );
  grille.setConstraints(infoPanel,regles );
  getContentPane().add(infoPanel );

  GridUtils.buildConstraints(regles,interior,0,0,0,1,1,1,50,5 );
  grille.setConstraints(ok,regles );
  getContentPane().add(ok );
  GridUtils.buildConstraints(regles,interior,0,0,1,1,1,1,50,5 );
  grille.setConstraints(quit,regles );
  getContentPane().add(quit );

  inter.getMenu().getParametres().setEnabled( false );
  inter.getMenu().getHelp().setEnabled( false );

  setVisible( true );
  infoPanel.getGraphics().drawImage(arrowleft,-1,-1,infoPanel );
  infoPanel.getGraphics().drawImage(arrowright,-1,-1,infoPanel );
  infoPanel.getGraphics().drawImage(arrowdown,-1,-1,infoPanel );
  infoPanel.getGraphics().drawImage(arrowup,-1,-1,infoPanel );
    }


    /**
     * Methode d'accs au bouton quitter
     */
    public JButton getQuitter()
    { return quit; }


    /**
     * Methode d'accs au bouton quitter
     */
    public JButton getOk()
    { return ok; }


    /**
     * Methode qui stoppe le tutorial
     */
    public void quitter()
    {
  setVisible(false );
  inter.getMenu().getParametres().setEnabled( true );
  inter.getMenu().getHelp().setEnabled( true );
  dispose();
    }

    /**
     * Methode qui stoppe le tutorial
     */
    public void suite()
    {
  etape++;
  String txt;
  switch (etape)
      {
      case 1 :
    txt = "<CENTER>"
        +"<FONT SIZE="+taille+">"
        +"Ce tutorial va vous montrer <BR>comment vous servir de ce logiciel."
        +"<BR>Suivez bien toutes les tapes !"
        +"<BR><BR>Bonne initiation."
        +"<BR><BR>PS : Suivez la flche pour <BR>savoir o regarder"
        +"</CENTER></FONT>";
    info.setText(txt );
    break;
      case 2 :
    txt = "<CENTER>"
        +"<FONT SIZE="+taille+">"
        +"L'interface se compose de 4 parties <BR><BR> - Le schma d'architecture"
        +"<BR><BR> - La Mmoire"
        +"<BR><BR> - L'diteur"
        +"<BR><BR> - Les commandes"
        +"</CENTER></FONT>";
    info.setText(txt );
    imCour=null;
    break;
      case 3 :
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"Le schma d'architecture</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> Il reprsente une architecture RISC simplifie"
        +"<BR><BR> Vous pourrez y voir le chemin des donnes,"
        +"<BR> Les noms des registres modifis,"
        +"<BR> L'opration de l'UAL,"
        +"<BR> La valeur du compteur de programme,"
        +"</CENTER></FONT>";
    info.setText(txt );
    setLocation(inter.getLocation().x+inter.getWidth()/2,getLocation().y );
    imCour=arrowleft;imX=10;imY=10;
    break;
      case 4 :
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"La Mmoire</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> Il y a une reprsentation de la RAM sur 8 bits"
        +"<BR><BR> Vous pouvez utiliser les barres de dfilement"
        +"<BR> pour voir les diffrentes cases"
        +"<BR> Vous pouvez choisir le type d'affichage :"
        +"<BR> Binaire, Dcimal ou Hexadcimal"
        +"<BR> Vous pouvez choisir les cases a afficher :"
        +"<BR> Toutes, Au Choix ou les cases Modifies"
        +"</CENTER></FONT>";
    info.setText(txt );
    setLocation(inter.getLocation().x,inter.getLocation().y );
    imCour=arrowright;imX=infoPanel.getWidth()-50;imY=10;
    break;
      case 5 :
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"La Mmoire</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> Allez-y, appuyez sur les boutons"
        +"<BR><BR> a droite pour modifier les types d'affichage"
        +"<BR><BR> Si vous choisissez le type Au Choix"
        +"<BR> une bote de dialogue vous demande quelles"
        +"<BR> sont les cases que vous voulez voir, faites vos"
        +"<BR> choix et cliquez sur fini."
        +"</CENTER></FONT>";
    info.setText(txt );
    setLocation(inter.getLocation().x,inter.getLocation().y );
    imCour=arrowright;imX=infoPanel.getWidth()-50;imY=10;
    break;
      case 6 :
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"La Mmoire</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> Il y a une reprsentation des registres,"
        +"<BR> avec des cases de 16 bits"
        +"<BR> Et une reprsentation des"
        +"<BR> drapeaux C,Z,N et V,"
        +"<BR><BR> La aussi il y a des barres de dfilement."
        +"<BR><BR> Le type d'affichage est"
        +"<BR> le mme que pour la RAM"
        +"</CENTER></FONT>";
    info.setText(txt );
    setLocation(inter.getLocation().x,inter.getLocation().y+inter.getHeight()/2 );
    imCour=arrowright;imX=infoPanel.getWidth()-50;imY=10;
    break;
      case 7 :
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"La Mmoire</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> Les registres comme la RAM sont modifis"
        +"<BR> en temps rel lors de l'excution,"
        +"<BR><BR> Vous pouvez modifier manuellement les "
        +"<BR> valeurs des registres et de la RAM a condition"
        +"<BR> d'tre en mode expert"
        +"<BR> Pour en savoir plus sur les drapeaux C,Z,N,V"
        +"<BR> voyez le menu d'aide"
        +"</CENTER></FONT>";
    info.setText(txt );
    setLocation(inter.getLocation().x,inter.getLocation().y+inter.getHeight()/2 );
    imCour=arrowright;imX=infoPanel.getWidth()-50;imY=10;
    break;
      case 8 :
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"L'diteur</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> Il permet de visualiser et d'diter"
        +"<BR> les lignes du programme a excuter"
        +"<BR> Vous pouvez diter une ligne en"
        +"<BR> double-cliquant dans la case"
        +"<BR> Vous pouvez charger et sauver des"
        +"<BR> fichiers en cliquant sur les boutons"
        +"<BR> charger et sauver."
        +"</CENTER></FONT>";
    info.setText(txt );
    setLocation(inter.getLocation().x,inter.getLocation().y+inter.getHeight()/2 );
    imCour=arrowright;imX=infoPanel.getWidth()-50;imY=infoPanel.getHeight()-30;
    break;
      case 9 :
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"L'diteur</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> En cliquant sur le bouton diter"
        +"<BR> vous pouvez ouvrir un diteur externe"
        +"<BR> qui permet d'arer un peu le code"
        +"<BR> et d'utiliser des raccourcis tel que :"
        +"<BR> copier, couper, coller ..."
        +"</CENTER></FONT>";
    info.setText(txt );
    setLocation(inter.getLocation().x,inter.getLocation().y+inter.getHeight()/2 );
    imCour=arrowright;imX=infoPanel.getWidth()-50;imY=infoPanel.getHeight()-30;
    break;
      case 10 :
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"Les commandes</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> Description des boutons :"
        +"<BR><BR> <B>Play </B> : Pour une excution continue."
        +"<BR>  <B>Pause</B> : Pour faire une pause."
        +"<BR>  <B>Stop</B> : Stopper et rinitialiser."
        +"</CENTER></FONT>";
    info.setText(txt );
    setLocation(inter.getLocation().x+inter.getWidth()/4,inter.getLocation().y+4*inter.getHeight()/10 );
    imCour=arrowdown;imX=infoPanel.getWidth()/2;imY=infoPanel.getHeight()-45;
    break;
      case 11 :
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"Les commandes</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> <B> Back</B> : Une instruction en avant."
        +"<BR>  <B>Next</B> : Une instruction en arrire."
        +"<BR>  <B>Step</B> : Executer pas a pas."
        +"<BR> L'Horloge sert a modifier la vitesse d'excution."
        +"</CENTER></FONT>";
    info.setText(txt );
    setLocation(inter.getLocation().x+inter.getWidth()/4,inter.getLocation().y+4*inter.getHeight()/10 );
    imCour=arrowdown;imX=infoPanel.getWidth()/2;imY=infoPanel.getHeight()-45;
    break;
      case 12 :
    inter.getUICmd().getControler().getModel().stop();
    inter.getUIEdit().getControl().getModel().setContentFromString("lih r1,10\nst(r1+0),r1" );
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"Les commandes</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> Les instructions : <B> lih r1,10 </B>"
        +"<BR>et <B> st(r1+0),r1 </B>"
        +"<BR> viennent d'apparatre dans l'diteur"
        +"<BR> Alors n'y touchez plus."
        +"</CENTER></FONT>";
    info.setText(txt );
    setLocation(inter.getLocation().x+inter.getWidth()/4,inter.getLocation().y+4*inter.getHeight()/10 );
    imCour=arrowdown;imX=infoPanel.getWidth()/2;imY=infoPanel.getHeight()-45;
    break;
      case 13 :
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"Gnral</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> Utilisez les boutons de commande,"
        +"<BR> pour excuter ces instructions a votre guise"
        +"<BR> et surveillez le schma, la RAM"
        +"<BR> et les registres."
        +"</CENTER></FONT>";
    info.setText(txt );
    setLocation(inter.getLocationOnScreen().x+inter.getWidth()/4,inter.getLocationOnScreen().y+inter.getHeight()/4 );
    imCour=null;
    break;
      case 14 :
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"Erreurs syntaxiques</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> Si une bote de dialogue s'ouvre"
        +"<BR> alors que vous voulez executer un"
        +"<BR> programme, cela signifie qu'il y a une erreur"
        +"<BR> de syntaxe ou de format a la ligne"
        +"<BR> donne, corrigez puis ressayez d'excuter"
        +"</CENTER></FONT>";
    info.setText(txt );
    setLocation(inter.getLocationOnScreen().x+inter.getWidth()/4,inter.getLocationOnScreen().y+inter.getHeight()/4 );
    imCour=null;
    break;
      case 15 :
    txt = "<CENTER>"
        +"<B><FONT COLOR=#FF0000 SIZE="+taille+">"
        +"Avant de vous laisser</FONT></B>"
        +"<FONT SIZE="+taille+">"
        +"<BR><BR> Pour plus d'informations,"
        +"<BR> n'hsitez pas a regardez le menu d'Aide"
        +"<BR> et nos questions/rponses."
        +"<BR><BR> Mais si vous avez oubli ce que vous"
        +"<BR> venez d'apprendre, laissez trainer votre"
        +"<BR> pointeur sur les diffrents lments,"
        +"<BR> vous pourrez l'apprendre a nouveau."
        +"</CENTER></FONT>";
    info.setText(txt );
    getContentPane().remove(ok );
    getContentPane().remove(quit );
    GridUtils.buildConstraints(regles,new Insets(0,0,0,0),0,0,1,1,2,1,50,5 );
    grille.setConstraints(quit,regles );
    getContentPane().add(quit );
    setLocation(inter.getLocationOnScreen().x+inter.getWidth()/4,inter.getLocationOnScreen().y+inter.getHeight()/4 );
    imCour=null;
    break;
      default : break;
      }
    }
}


