package Utilitaires;


/**
 *Classe qui contient des fonctions utilitaires telles que
 *les conversions binaire -> decimal, hexadecimal -> decimal
 */
public class Utils
{
  /**
   * Fonction qui effectue la conversion binaire(non sign) -> decimal
   * @param b : Chane de caractres reprsentant un nombre binaire non sign
   * @return Un entier qui est la valeur dcimale de b
   */
  public static int unsignedBinToInt( String b ) throws NumberFormatException
  {
    int     lRes = 0;
    String  lTmp = "";
    int     lSize = b.length();
    int     lBit;
    
    for( int i=0; i < lSize; i++ )
    {
      lTmp = b.substring( i, i+1 );
      lBit = Integer.valueOf( lTmp ).intValue();
      if ( lBit != 0 && lBit != 1 ) { throw new NumberFormatException( "" ); }
      lRes = 2*lRes + lBit;
    }
    return lRes;
  }
  
  
  /**
   * Fonction qui effectue la conversion binaire(sign) -> decimal
   * @param b : Chane de caractres reprsentant un nombre binaire sign
   * @return Un entier qui est la valeur dcimale de b
   */
  public static int signedBinToInt( String b ) throws NumberFormatException
  {
    if ( (b.substring(0,1)).equals("1") )
    {
      b = opposeBin( b );
      return -unsignedBinToInt( b );
    }
    else
      return unsignedBinToInt( b );
  }
  
  
  /**
   *Fonction qui effectue la conversion hexadecimal(non sign) -> decimal
   *@param b : Chane de caractres reprsentant un nombre hexadecimal non sign
   *@return Un entier qui est la valeur dcimale de b
   */
  public static int unsignedHexToInt(String b)
  {
    int lRes = 0;
    String lTmp = "";
    int lSize = b.length();
    int facteur;
    
    for( int i = 0; i < lSize; i++ )
    {
      lTmp=b.substring( i, i+1 );
      
      if ( lTmp.equals( "a" ) || lTmp.equals( "A" ) ) facteur=10; else
      if ( lTmp.equals( "b" ) || lTmp.equals( "B" ) ) facteur=11; else
      if ( lTmp.equals( "c" ) || lTmp.equals( "C" ) ) facteur=12; else
      if ( lTmp.equals( "d" ) || lTmp.equals( "D" ) ) facteur=13; else
      if ( lTmp.equals( "e" ) || lTmp.equals( "E" ) ) facteur=14; else
      if ( lTmp.equals( "f" ) || lTmp.equals( "F" ) ) facteur=15;
      else facteur = ((Integer.valueOf( lTmp )).intValue())%10;
      lRes = 16*lRes + facteur;
    }
    return lRes;
  }
  
  
  /**
   * Fonction qui effectue la conversion hexadecimal(sign) -> decimal
   * @param b : Chane de caractres reprsentant un nombre hexadecimal sign
   * @param lSize : La lSize en nombre de bits du nombre
   * @return Un entier qui est la valeur dcimale de b
   */
  public static int signedHexToInt( String inHex, int lSize )
  {
    String bin = hexToBin( inHex );
    
    if ( (bin.substring(0,1)).equals("1") && bin.length() == lSize )
    {
      System.out.println( "hexToBin : " + bin );
      bin = signedExtension( bin, lSize ); // [YL] : Franchement inutile d'aprs la condition du if
      System.out.println( "signedExtension : " + bin );
      bin = opposeBin( bin );
      System.out.println( "opposeBin : " + bin );
      return - unsignedBinToInt(bin );
    }
    else
    {
      // System.out.println( "hexToBin : " + bin );
      return unsignedHexToInt( inHex );
    }
  }
  
  
  /**
   * Fonction qui effectue la fonction puissance x power y
   * @param x : entier
   * @param y : entier (y doit etre positif !!!)
   * @return x a la puissance y
   */
  public static int power(int x, int y)
  {
    int lRes = 1;
    for( int i = 0; i < y; i++ ) { lRes*=x; }
    return lRes;
  }
  
  
  
  /**
   * Fonction utile a la conversion binaire(signe) -> decimal
   * @param b : un nombe binaire sign
   * @return L'oppos de b en binaire
   */
  public static String opposeBin( String b )
  {
    String lRes = "";
    int lCarry = 1;
    String lTmp = "";
    int lSize = b.length();
    int lTrit;
    
    for( int i = 0; i < lSize; i++ )
    {
      lTmp=b.substring( lSize - (i+1), lSize - i );
      lTrit = (1 - (Integer.valueOf( lTmp ).intValue() % 2)) + lCarry;
      switch( lTrit )
      {
      case 0:  lRes = "0" + lRes; lCarry = 0; break;
      case 1:  lRes = "1" + lRes; lCarry = 0; break;
      default: lRes = "0" + lRes; lCarry = 1; break;
      }
    }
    return lRes;
  }
  
  /**
   * Fonction utile a la conversion hexadecimal(sign) -> decimal
   * @param b : un chiffre hexadecimal non sign
   * @return La valeur binaire non signe du chiffre
   */
  public static String hexCharToBin( String b )
  {
    int lTmp2;
    String lTmp = "";
    
    if ( lTmp.equals( "a" ) || lTmp.equals( "A" ) ) lTmp2=10; else
    if ( lTmp.equals( "b" ) || lTmp.equals( "B" ) ) lTmp2=11; else
    if ( lTmp.equals( "c" ) || lTmp.equals( "C" ) ) lTmp2=12; else
    if ( lTmp.equals( "d" ) || lTmp.equals( "D" ) ) lTmp2=13; else
    if ( lTmp.equals( "e" ) || lTmp.equals( "E" ) ) lTmp2=14; else
    if ( lTmp.equals( "f" ) || lTmp.equals( "F" ) ) lTmp2=15;
    else lTmp2 = ((Integer.valueOf(b)).intValue()) % 10;
    
    lTmp = Integer.toBinaryString( lTmp2 );
    lTmp = unsignedExtension( lTmp, 4 );
    
    /* if(lTmp.length()==1) lTmp="000"+lTmp; if(lTmp.length()==2) lTmp="00"+lTmp; if(lTmp.length()==3) lTmp="0"+lTmp; */
    return lTmp;
  }
  
  
  
  /**
   * Fonction utile a la conversion hexadecimal(sign) -> decimal
   * @param b : un nombre hexadecimal non sign
   * @return La valeur binaire non signe du nombre
   */
  public static String hexToBin( String b )
  {
    String lRes="";
    int lSize = b.length();
    for( int i=lSize-1; i >= 1; i-- )
    lRes=hexCharToBin(b.substring(i,i+1))+lRes;
    
    String s = b.substring(0,1 );
    int lTmp2;
    if ( s.equals( "a" ) || s.equals( "A" ) ) lTmp2=10; else
    if ( s.equals( "b" ) || s.equals( "B" ) ) lTmp2=11; else
    if ( s.equals( "c" ) || s.equals( "C" ) ) lTmp2=12; else
    if ( s.equals( "d" ) || s.equals( "D" ) ) lTmp2=13; else
    if ( s.equals( "e" ) || s.equals( "E" ) ) lTmp2=14; else
    if ( s.equals( "f" ) || s.equals( "F" ) ) lTmp2=15;
    else lTmp2=(Integer.valueOf(s)).intValue();
    String lTmp=Integer.toBinaryString(lTmp2 );
    
    return lTmp+lRes;
  }
  
  
  
  /**
   * Fonction utile a la conversion hexadecimal(sign) -> decimal
   * @param b : un nombre binaire non sign
   * @return La valeur hexadecimale non signe : sur 1 caractre
   */
  public static String binToHexChar( String b ) { return Integer.toHexString( unsignedBinToInt( b ) ); }
  
  
  
  /**
   * Fonction utile a la conversion hexadecimal(signe) -> decimal
   * @param b : un nombre binaire non signe
   * @return La valeur hexadecimale non signee du nombre
   */
  public static String binToHex( String b )
  {
    String lRes = "";
    int lSize = b.length();
    if( (lSize % 4) !=0 )
    {
      lSize += 3;
      lSize /= 4;
      lSize *= 4;
      b = unsignedExtension( b, lSize );
    }
    
    for( int i = 0; i < lSize-3; i += 4 )
      lRes += binToHexChar(b.substring( i, i+4 ) );
    return lRes;
  }
  
  
  
  /**
   * Complte une sequence binaire non signe sur n bits
   * @param val : la squence a completer
   * @param n : le nb de bits sur lequel completer
   * @return la squence complte
   */
  public static String unsignedExtension( String val, int n )
  {
    String lTmp= "0000000000000000" + val;
    return lTmp.substring(lTmp.length()-n,lTmp.length() );
  }
  
  /**
   * Complte une sequence binaire signe sur n bits
   * @param val : la squence a completer
   * @param inSize : le nb de bits sur lequel completer
   * @return la squence complte
   */
  public static String signedExtension( String val, int inSize )
  {
    String lTmp = "";
    if ((val.substring(0,1)).equals("1")) lTmp = "1111111111111111" + val;
    else lTmp = "0000000000000000" + val;
    return lTmp.substring( lTmp.length()-inSize, lTmp.length() );
  }
  
  
  
  /**
   * Complte une sequence hexadecimale signe sur n caractres
   * @param val : la squence a completer
   * @param n : le nb de bits sur lequel completer
   * @return la squence complte
   */
  public static String setToNuHexChars( String val, int n )
  {
    String lTmp= "0000"+val;
    return lTmp.substring(lTmp.length()-n,lTmp.length() );
  }
  
  
  
  /**
   * Fonction qui effectue la conversion decimal -> binaire(non signe)
   * @param inValue : l'entier ***positif!!!*** a convertir
   * @return Une chane de caracteres binaires reprsentant l'entier
   */
  public static String unsignedIntToBin( int inValue )
  {
    int     reste=0;
    String  lRes="";
    
    do {
      reste   =  inValue % 2;
      inValue /= 2;
      lRes    =  reste + lRes;
    } while ( inValue != 0 );
    
    return( unsignedExtension( lRes, 16 ) );
  }
  
  
  
  /**
   * Fonction qui effectue la conversion decimal -> binaire(signe)
   * @param b : l'entier a convertir
   * @return Une chane de caractres binaires reprsentant l'entier
   */
  public static String signedIntToBin(int v)
  {
    String lRes;
    if ( v < 0 ) lRes = opposeBin( unsignedIntToBin( -v ) );
    else         lRes = unsignedIntToBin( v );

    return lRes;
  }
  
  
  
  /**
   * Fonction d'addition de 2 nombres binaires de mme lSize
   * @param b1 : un nombe binaire
   * @param b2 : un nombre binaire
   * @param lSize : le nombre de bits du rsultat
   * @return b1+b2
   */
  public static Result addBin( String b1, String b2, int lSize )
  {
    String  lRes = "";
    int     lSum = 0;
    boolean lS1 = (b1.substring( 0, 1 ).equals( "1" ));
    boolean lS2 = (b2.substring( 0, 1 ).equals( "1" ));
    
    for(int i=0;i<lSize;i++)
    {
      lSum += (Integer.valueOf( b1.substring(lSize-(i+1),lSize-i ) ).intValue())%2;
      lSum += (Integer.valueOf( b2.substring(lSize-(i+1),lSize-i ) ).intValue())%2;
      
      switch( lSum )
      {
      case 0:  lRes = "0" + lRes; lSum = 0; break;
      case 1:  lRes = "1" + lRes; lSum = 0; break;
      case 2:  lRes = "0" + lRes; lSum = 1; break;
      default: lRes = "1" + lRes; lSum = 1; break;
      }
    }
    boolean lOverFlow = (lS1 && lS2 && (lRes.equals( "0" ))) || (!lS1 && !lS2 && (lRes.equals( "1" )));
    return new Result( lRes, lSum, lOverFlow?1:0 );
  }
  
  
  
  /**
   * Fonction AND de 2 nombres binaires de mme lSize
   * @param b1 : un nombe binaire
   * @param b2 : un nombre binaire
   * @param lSize : le nombre de bits du rsultat
   * @return b1 AND b2
   */
  public static Result andBin( String b1, String b2, int lSize )
  {
    String lRes = "";
    int    lSum = 0;
    
    for( int i = 0; i < lSize; i++ )
    {
      lSum = (Integer.valueOf( b1.substring( lSize-(i+1), lSize-i ) ).intValue())%2;
      lSum += (Integer.valueOf( b2.substring( lSize-(i+1), lSize-i ) ).intValue())%2;
      
      if( lSum == 2 )
        lRes = "1" + lRes;
      else
        lRes = "0" + lRes;
    }
    return new Result( lRes, 0, 0 );
  }
  
  
  
  /**
   * Fonction OR de 2 nombres binaires de mme lSize
   * @param b1 : un nombe binaire
   * @param b2 : un nombre binaire
   * @param lSize : le nombre de bits du rsultat
   * @return b1 OR b2
   */
  public static Result orBin(String b1,String b2,int lSize)
  {
    String lRes="";
    int    lSum=0;
    
    for( int i = 0; i < lSize; i++ )
    {
      lSum = (Integer.valueOf( b1.substring( lSize-(i+1), lSize-i ) ).intValue())%2;
      lSum += (Integer.valueOf( b2.substring( lSize-(i+1), lSize-i ) ).intValue())%2;
      
      if( lSum == 0 )
        lRes = "0" + lRes;
      else
        lRes = "1" + lRes;
    }
    return new Result( lRes, 0, 0 );
  }
  
  
  
  /**
   * Fonction qui effectue la conversion decimal -> hexadecimal(sign)
   * @param b : l'entier a convertir
   * @return Une chane de caractres hexadecimaux reprsentant l'entier
   */
  public static String signedIntToHex( int v ) { return binToHex( signedIntToBin( v ) ); }
  
  /**
   * retourne le codage/format d'une instruction
   * @param s : l'instruction
   * @return Une chane de caractres binaire reprsentant l'instruction
   */
  public static String getCode(String s)
  {
    if ( s.equals( "lih" )   || s.equals( "Lih" )   || s.equals( "LIH") )   return null;
    if ( s.equals( "b" )     || s.equals( "b" )     || s.equals( "B") )     return PixConstants.B;
    if ( s.equals( "ba" )    || s.equals( "Ba" )    || s.equals( "BA") )    return PixConstants.BA;
    if ( s.equals( "beq" )   || s.equals( "Beq" )   || s.equals( "BEQ") )   return PixConstants.BEQ;
    if ( s.equals( "bne" )   || s.equals( "Bne" )   || s.equals( "BNE") )   return PixConstants.BNE;
    if ( s.equals( "bge" )   || s.equals( "Bge" )   || s.equals( "BGE") )   return PixConstants.BGE;
    if ( s.equals( "bgt" )   || s.equals( "Bgt" )   || s.equals( "BGT") )   return PixConstants.BGT;
    if ( s.equals( "ble" )   || s.equals( "Ble" )   || s.equals( "BLE") )   return PixConstants.BLE;
    if ( s.equals( "blt" )   || s.equals( "Blt" )   || s.equals( "BLT") )   return PixConstants.BLT;
    if ( s.equals( "bvs" )   || s.equals( "Bvs" )   || s.equals( "BVS") )   return PixConstants.BVS;
    if ( s.equals( "bvc" )   || s.equals( "Bvc" )   || s.equals( "BVC") )   return PixConstants.BVC;
    if ( s.equals( "add" )   || s.equals( "Add" )   || s.equals( "ADD") )   return PixConstants.ADD;
    if ( s.equals( "add." )  || s.equals( "Add." )  || s.equals( "ADD.") )  return PixConstants.ADDPT;
    if ( s.equals( "sub" )   || s.equals( "Sub" )   || s.equals( "SUB") )   return PixConstants.SUB;
    if ( s.equals( "sub." )  || s.equals( "Sub." )  || s.equals( "SUB.") )  return PixConstants.SUBPT;
    if ( s.equals( "and." )  || s.equals( "And." )  || s.equals( "AND.") )  return PixConstants.ANDPT;
    if ( s.equals( "or" )    || s.equals( "Or" )    || s.equals( "OR") )    return PixConstants.OR;
    if ( s.equals( "ldx" )   || s.equals( "Ldx" )   || s.equals( "LDX") )   return PixConstants.LDX;
    if ( s.equals( "stx" )   || s.equals( "Stx" )   || s.equals( "STX") )   return PixConstants.STX;
    if ( s.equals( "ldbx" )  || s.equals( "Ldbx" )  || s.equals( "LDBX") )  return PixConstants.LDBX;
    if ( s.equals( "ldsbx" ) || s.equals( "Ldsbx" ) || s.equals( "LDSBX") ) return PixConstants.LDSBX;
    if ( s.equals( "stbx" )  || s.equals( "Stbx" )  || s.equals( "STBX") )  return PixConstants.STBX;
    if ( s.equals( "addi" )  || s.equals( "Addi" )  || s.equals( "ADDI") )  return PixConstants.ADDI;
    if ( s.equals( "addi." ) || s.equals( "Addi." ) || s.equals( "ADDI.") ) return PixConstants.ADDIPT;
    if ( s.equals( "andi." ) || s.equals( "Andi." ) || s.equals( "ANDI.") ) return PixConstants.ANDIPT;
    if ( s.equals( "ori" )   || s.equals( "Ori" )   || s.equals( "ORI") )   return PixConstants.ORI;
    if ( s.equals( "ld" )    || s.equals( "Ld" )    || s.equals( "LD") )    return PixConstants.LD;
    if ( s.equals( "st" )    || s.equals( "St" )    || s.equals( "ST") )    return PixConstants.ST;
    if ( s.equals( "ldb" )   || s.equals( "Ldb" )   || s.equals( "LDB") )   return PixConstants.LDB;
    if ( s.equals( "ldsb" )  || s.equals( "Ldsb" )  || s.equals( "LDSB") )  return PixConstants.LDSB;
    if ( s.equals( "stb" )   || s.equals( "Stb" )   || s.equals( "STB") )   return PixConstants.STB;
    if ( s.equals( "lsl" )   || s.equals( "Lsl" )   || s.equals( "LSL") )   return PixConstants.LSL;
    if ( s.equals( "rol" )   || s.equals( "Rol" )   || s.equals( "ROL") )   return PixConstants.ROL;
    if ( s.equals( "lsr" )   || s.equals( "Lsr" )   || s.equals( "LSR") )   return PixConstants.LSR;
    if ( s.equals( "asr" )   || s.equals( "Asr" )   || s.equals( "ASR") )   return PixConstants.ASR;
    return null;
  }
}
